<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Mp extends CI_Controller {
    function __construct() {
        parent::__construct();
        $this->db_default = $this->load->database('default', TRUE);
        $this->id_table="mp";
        $this->req_base = "SELECT
    		mp.nom as 'Nom',
    		mp.description as 'Description',
    		mp.utilisateur as 'Utilisateur',
    		mp.pwd as 'Pwd',
    		mp.id as 'id',
    		mp.show_pwd as show_pwd
    		FROM `mp`
    	";
    	$this->left_join = "";

    }

	public function index() {
		$titre="MP";
		$breadcrumbs = array($titre);
		// Appel Ajax
		$contenu .= '
			<script type="text/javascript" language="javascript" >
				$(document).ready(function() {
					var dataTable = $("#'.$this->id_table.'").DataTable( {
						"processing": true,
						"serverSide": true,
						"order": [[ 0, "desc" ]],
						// "columnDefs": [{"targets": 8,"orderable": false} ],
						"ajax":{
							"url" :"/mp/liste_ajax",
							"type" : "post"
						},
						"drawCallback": function(settings, json) {
							chargement();
  						},
  						"responsive":true
					});
				} );
				var clipboard = new ClipboardJS(".clipboard");
				clipboard.on("success", function(e) {
	    			alertMe("success", "Texte copié","1000");
				});
			</script>
		';

		
		
		if(get_role(array())) {
			// Ajout
			$contenu .= '<div class="mb20">'.jqHref("add","/".$this->id_table."/add_ed_form","","Ajouter","btn btn-xs btn-success","glyphicon glyphicon-plus","Ajouter",false,"mp","Ajouter").'</div>';
			//tableau vide
			$get_field_req = get_field_req($this->req_base,array("mp.id","mp.show_pwd"),array("Action"));
			$contenu .= build_empty_table($get_field_req['a_title_col'],$this->id_table,"table table-bordered table-hover table-striped");
		}
		// if(!get_role(array(1,2))) {
		// 	$contenu = '<div class="alert alert-danger">Attention !!!! Vous n\'êtes pas connecté</div>';
		// }


		$this->load->view('base',array('post'=>get_defined_vars()));
	}

	public function add_ed_form() {
		// ajout
		if(!isset($_POST['id'])) {
			$bt="Envoyer";
			$show_hide=0;
		}
		// Modification
		else {
			//Recuperation des variables de l'array $_POST
			if(is_array($_POST)) foreach($_POST as $key => $value) { ${$key} = $value; }
			$bt="Enregistrer la modification";
			$req = "SELECT * FROM `mp` WHERE 1 AND `id` = '".$_POST['id']."'";
			$a_res = $this->db->query($req)->result_array();
			//Recuperation des variables de l'array $a_res[0]
			if(is_array($a_res[0])) foreach($a_res[0] as $key => $value) { ${$key} = $value; }
		}

		$form = $this->form->create(array("fname"=>"add_ed_form","action"=>"/mp/add_ed","class"=>"mt20","button"=>$bt))
				->grid(3)
				->input(array("type"=>"text","name"=>"nom","label"=>"Nom","valeur"=>$nom,"validate"=>array("type"=>"required")))
				->input(array("type"=>"textarea","name"=>"description","label"=>"Description","valeur"=>$description))
				->input(array("type"=>"text","name"=>"utilisateur","label"=>"Utilisateur","valeur"=>$utilisateur,"validate"=>array("type"=>"required")))
				->input(array("type"=>"text","name"=>"pwd","label"=>"Pwd","valeur"=>$pwd,"validate"=>array("type"=>"required")))
				->input(array("type"=>"radio","name"=>"show_pwd","label"=>"Afficher le mot de passe","option"=>array("Non"=>0,"Oui"=>1),"valeur"=>$show_pwd,"validate"=>array("type"=>"required")))
				->input(array("type"=>"hidden","name"=>"id","valeur"=>$id))
				->render();
		echo $form;
	}

	public function add_ed() {
		if(!$_POST['id'])
			insert($_POST,$this->id_table,array());
		else
			update($_POST,$this->id_table," AND id='".$_POST['id']."'",array());
		echo javascript("$('#".$this->id_table."').DataTable().ajax.reload(null, false );") ;
		echo javascript("mpClose();") ;	
	}

	public function del() {
		$req = "DELETE FROM `mp` WHERE 1 AND `id`='".$_POST['id']."'";
		$a_res = $this->db->query($req);
		echo javascript("$('#".$this->id_table."').DataTable().ajax.reload(null, false );");
	}

    public function liste_ajax() {
    	$r= $_REQUEST;
    	$search = $r['search']['value'];
		$get_field_req=get_field_req($this->req_base);
    	$orderby_col = $get_field_req['a_num_col'][$r['order'][0]['column']];
    	$orderby_direction = $r['order'][0]['dir'];
    	$order_by = "ORDER BY ".$orderby_col." ".$orderby_direction;
    	$limit = "LIMIT ".$r['start'].",".$r['length'];
    	$left_join = $this->left_join;

    	//recherche
    	if ($search)
    		$where .= where_creator($this->req_base, $search);

    	//La requette
    	$req = $this->req_base;
    	$req_total = $req." ".$left_join."	WHERE 1 ".$where." ".$order_by." ".$limit;
    	$a_res = $this->db->query($req_total)->result_array();
    	$a_res = nl2br_array($a_res);

    	//Création du resultat
    	$a_data=array();
    	$i=0;
    	foreach ($a_res as $key => $value) {
    		$j=0;
    		foreach ($value as $key_2 => $value_2) {
    			$a_data[$i][$j] = $value_2;
    			$j++;
    		}
    		// numéro du champ action
    		$n=4;
			//les champs manuels
			//show_pwd
			$show_pwd = $a_data[$i][5];
			$id = $a_data[$i][$n];
			// $pwd = '<font style="background-color:#000000">'.$a_data[$i][3].'</font>';
			if($show_pwd == 0)
				$backgroud_color="background-color:#000000;";
			else 
				$backgroud_color="";

			$desciption = $a_data[$i][1];
			$a_data[$i][1] = clickable_link($a_data[$i][1]);
			// Champ utilisateur
			$utilisateur = $a_data[$i][2].' <a href="#" class="clipboard btn btn-default btn-xs" data-clipboard-text="'.$a_data[$i][2].'">&nbsp;<i class="glyphicon glyphicon-copy"></i> </a>';
			$a_data[$i][2] = $utilisateur;

			// Champ pwd
			$pwd = '<input id="#pwd_'.$id.'" style="'.$backgroud_color.'border:none;color:#000000" onclick="this.select()" value="'.$a_data[$i][3].'" > <a href="#" class="clipboard btn btn-default btn-xs" data-clipboard-text="'.$a_data[$i][3].'">&nbsp;<i class="glyphicon glyphicon-copy"></i> </a> ';
			$a_data[$i][3] = $pwd;

			//champ action 
			$a_data[$i][$n] = jqHref("edit_".$i,"/mp/add_ed_form","id=".$id,"","btn btn-xs btn-primary","glyphicon glyphicon-edit","Modifier",false,"mp","Modifier");
			$a_data[$i][$n] .= jqHref("del_".$i,"/mp/del","id=".$id,"","btn btn-xs btn-danger","glyphicon glyphicon-trash","Supprimer","Supprimer ?","jquerize","Supprimer");
    			
    		$i++;
    	}

    	//Nb total
    	$req = "SELECT COUNT(".$this->id_table.".id) as nb_total FROM `".$this->id_table."` WHERE 1";
    	$a_res_nb_total = $this->db->query($req)->result_array();

    	//Nb total after search
    	$req = "SELECT COUNT(".$this->id_table.".id) as nb_search FROM `".$this->id_table."` ".$this->left_join." WHERE 1 ".$where;
    	$a_res_nb_after_search = $this->db->query($req)->result_array();

		$json_data = array(
			"draw"            => intval( $r['draw'] ),   // for every request/draw by clientside , they send a number as a parameter, when they recieve a response/data they first check the draw number, so we are sending same number in draw. 
			"recordsTotal"    => intval( $a_res_nb_total[0]['nb_total'] ),  // total number of records
			"recordsFiltered" => intval( $a_res_nb_after_search[0]['nb_search'] ), // total number of records after searching, if there is no searching then totalFiltered = totalData
			"data"            => $a_data   // total data array
		);
		echo json_encode($json_data);
    }
}
