<?php
defined('BASEPATH') OR exit('No direct script access allowed');

class Utilisateur extends CI_Controller {
	public $show_admin=1;
	public $mod_name;
	public $table = "utilisateur";
	public $orderBy = "id";
	public $asc_desc = "desc";
	public $a_res_sql_liste;
	public $classname = __CLASS__;
	public $css_class_liste = "ul";
	public $ajouter = ""; // on ne doit pas pouvoir ajouter un utilisateur
	public $modifier = "Modifier un utilisateur";
	public $nb_max_img = 1;
	public $id_name = "id";
	public $show_id = false;
	public $titre = "Gestion des utilisateurs";
	public $breadcrumbs = array("Gestion des utilisateurs");
	public $get_role = array(1);
	public $col = array(
		"id"=>"id",
		"username"=>"utilisateur",
		"realname"=>"Prénom NOM",
		"email"=>"Email",
	);
	public $variable_a_passer = array(
		"table",
		"orderBy",
		"asc_desc",
		"css_class_liste",
		"col",
		"classname",
		"id_name",
		"ajouter",
		"get_role"
	);
	public $database = "default";

    function __construct() {
        parent::__construct();
       	//get col number for orderby
       	foreach (array_keys($this->col) as $key => $value) {
       		if($this->orderBy == $value) $col_orderby = $key;
       	}
       	$post['col_orderby'] = $col_orderby;
       	$post['where'] = " AND `enabled` = 1 ";

        foreach ($this->variable_a_passer as $value) {
        	$post[$value] = $this->$value;
        }
        if($this->database) {
        	$post['database'] = $this->database;
        	$this->db_crud = $this->load->database('default', TRUE);
        }
        $this->db_default = $this->load->database('default', TRUE); 
    }

    public function add_ed_form() {
    	//Si c'est un ajout
    	if (!$_POST['id']) {
    		$bt = "Ajouter l'utilisateur";
    	}
    	else {
    		// Obtenir les informations de l'utilisateur sélectionné
    		$req = "SELECT username,realname,email,id_equipe,role FROM `utilisateur` WHERE 1 AND `id` LIKE '".$_POST['id']."' LIMIT 1";
    		$a_res = $this->db->query($req)->result_array();
    		//Recuperation des variables de l'array $a_res
    		if(is_array($a_res[0])) foreach($a_res[0] as $key => $value) { ${$key} = $value; }
    		$a_role_selected=unserialize($role);

    		$bt = "Enregistrer la modification";
    	}

    	//Obtenir la liste des équipes
    	$req='SELECT * FROM pm_equipe';
    	$a_res = $this->db->query($req)->result_array();

		foreach ($a_res as $key => $value) {
			$a_option_equipe[$value['nom']] = $value['id'];
		}

		//Obtenir la liste des rôle
		$req = 'SELECT description,id_role FROM `role`';
		$a_res = $this->db->query($req)->result_array();
		foreach ($a_res as $key => $value) {
			$a_option_role[$value['description']] = $value['id_role'];
		}

		$contenu = $this->form->create(array("fname"=>"add_ed_form","action"=>"/".strtolower($this->classname)."/add_ed","class"=>"mt20","button"=>$bt))
			->grid(3)
			->input(array("type"=>"text","name"=>"username","label"=>"Utilisateur","valeur"=>$username,"validate"=>array("type"=>"required")))
			->input(array("type"=>"text","name"=>"realname","label"=>"Nom Prénom","valeur"=>$realname,"validate"=>array("type"=>"required")))
			->input(array("type"=>"text","name"=>"email","label"=>"Email","valeur"=>$email,"validate"=>array("type"=>"required")))
			->input(array("type"=>"select","name"=>"id_equipe","label"=>"Equipe","option"=>$a_option_equipe,"valeur"=>$id_equipe,"validate"=>array("type"=>"required")))
			->input(array("type"=>"select-multiple","name"=>"role[]","label"=>"Role","option"=>$a_option_role,"class"=>"multiselect_it","valeur"=>$a_role_selected,"validate"=>array("type"=>"required")))
			->input(array("type"=>"hidden","name"=>"id","valeur"=>$_POST['id']))
			->render()
		;
		echo $contenu;
    }

	public function add_ed_form_() {
		get_role_redirect($this->get_role);
		// Si Ajout
		if(!isset($_POST['id'])) {
			$bouton = "Envoyer";
		}
		// Si modification
		else {
			$req = 'SELECT * FROM `'.$this->table.'` WHERE '.$this->id_name.'='.$_POST['id'].' LIMIT 1';
     		$a_res = $this->db_crud->query($req)->result_array();
     		$post = $a_res[0];
     		if(is_array($post)) foreach($post as $key => $value) { ${$key} = $value; }
     		//get role info
     		$req = "SELECT role FROM `utilisateur` WHERE `username` = '".$post['username']."'";
     		$a_res =  $this->db_default->query($req)->result_array();

     		if(is_serialized($a_res[0]['role']))
     			$a_role_selected = unserialize($a_res[0]['role']);
			$bouton = "Enregistrer la modification";
		}

		$contenu = $this->form->create(array("fname"=>"add_ed_form","action"=>"/".strtolower($this->classname)."/add_ed","class"=>"mt20","button"=>$bouton))
			->grid(3)
			->input(array("type"=>"text","name"=>"username","label"=>"Utilisateur","valeur"=>$username,"validate"=>array("type"=>"required")))
			->input(array("type"=>"text","name"=>"realname","label"=>"Prénom Nom","valeur"=>$realname,"validate"=>array("type"=>"required")))
			->input(array("type"=>"text","name"=>"email","label"=>"Email","valeur"=>$email,"validate"=>array("type"=>"required")))
			->input(array("type"=>"select-multiple","name"=>"role[]","label"=>"Role","option"=>$a_option_role,"class"=>"multiselect_it","valeur"=>$a_role_selected,"validate"=>array("type"=>"required")))
			->input(array("type"=>"hidden","name"=>"id","valeur"=>$_POST['id']))
			->render()
		;

		echo $contenu;
	}

	public function index() {
		get_role_redirect($this->get_role);
		$contenu = '<div id="r_liste">'.$this->liste().'</div>';
		$titre = $this->titre;
		$breadcrumbs = $this->breadcrumbs;
		$this->load->view('base',array('post'=>get_defined_vars()));

	}

	public function liste() {
		//Mettre la liste des équipes dans un array 
		$req = "SELECT * from `pm_equipe`";
		$a_res = $this->db_default->query($req)->result_array();
		foreach ($a_res as $key => $value) {
			$a_equipe[$value['id']] = $value['nom'];
		}		
		
		//Mettre la liste des roles dans un array
		$req = "SELECT id_role,description from role";
		$a_res = $this->db_default->query($req)->result_array();
		foreach ($a_res as $key => $value) {
			$role[$value['id_role']] = $value['description'];
		}

		$req = "SELECT 
			utilisateur.id,
			utilisateur.username as 'Num d\'utilisateur',
			utilisateur.id_equipe as id_equipe,
			utilisateur.role as Rôle,
			utilisateur.realname as 'NOM Prénom',
			utilisateur.email as Email
		FROM `utilisateur`";
		$a_res =  $this->db_default->query($req)->result_array();
		//recreation de l'array histoire d'afficher ce qu'on veut
		$i=0;

		foreach ($a_res as $key => $value) {
			$id=$a_res[$i]['id'];
			
			//equipe
			$a_res[$i]['Equipe'] = $a_equipe[$a_res[$i]['id_equipe']];
			unset($a_res[$i]['id_equipe']);

			//ajout des boutons actions
			$bt_action = jqHref("user_ed_".$id,"/utilisateur/add_ed_form","id=".$id,"","btn btn-xs btn-primary","glyphicon glyphicon-edit","Modifier l\'utilisateur",false,"mp","Modifier l\'utilisateur");
			$bt_action .= jqHref("user_del_".$id,"/".portail."/utilisateur/del","id=".$id,"","btn btn-xs btn-danger","glyphicon glyphicon-trash","Supprimer l\'utilisateur","Voulez-vous vraiment supprimer","jquerize","Supprimer l\'utilisateur");
			$a_res[$i]['Action'] = $bt_action;
			unset($a_res[$i]['id']);

			//role
			$a_role = unserialize($a_res[$i]['Rôle']);
			$liste_role='';
			foreach ($a_role as $key_2 => $value_2) {
				$liste_role .= '<div>'.$role[$value_2].'</div>';
			}
			$a_res[$i]['Rôle'] = $liste_role;
			$i++;
		}
		//bouton ajouter
		$contenu = '<div class="mt20 mb20">'.jqHref("add","/utilisateur/add_ed_form","","Ajouter un utilisateur","btn btn-xs btn-success","glyphicon glyphicon-plus","Ajouter un utilisateur",false,"mp","Ajouter un utilisateur").'</div>';

		//tableau
		$contenu .= build_table_v2(array("array"=>$a_res));

		return $contenu;
	}

	public function del() {
		$req = "DELETE FROM utilisateur WHERE `id`='".$_POST['id']."' ";
		$a_res =  $this->db_default->query($req);
		echo afficher_html("r_liste",$this->liste());
	}

	public function add_ed() {
		if(is_array($_POST)) foreach($_POST as $key => $value) { ${$key} = $value; }
		$role = serialize($_POST['role']);
		//mot de passe par défaut = lbp2018
		$pwd_default = "6e78f95fe4693907bcd0426a42427da3";
		get_role_redirect($this->get_role);
		// Ajout
		//si l'utilisateur n'existe pas on l'ajoute
		if(!$id) {
			$req = "SELECT COUNT(id) as nb FROM `utilisateur` WHERE `username` = '".$username."'";
			$a_res = $this->db_default->query($req)->result_array();
			if($a_res[0]['nb'] != 0) {
				echo alert("danger","Attention! l'utilisateur ".$_POST['username']." existe déjà",$timeout=5000);
				die();
			}
			$req = "INSERT INTO utilisateur (`username`,`realname`,`email`,`id_equipe`,`role`,`enabled`,`password`) VALUES('".$username."','".$realname."','".$email."','".$id_equipe."','".$role."',1,'".$pwd_default."')";
			$a_res =  $this->db_default->query($req);
		}
		//  Modification
		else {
			$req = "UPDATE utilisateur SET `username`='".$username."',`realname`='".$realname."',`email`='".$email."',`id_equipe`='".$id_equipe."',`role`='".$role."' WHERE 1 AND `id` = '".$id."'";
			$a_res =  $this->db_default->query($req);
		}
		echo afficher_html("r_liste",$this->liste());
		echo javascript("mpClose();");
	}
	/*
		Fin partie à ne pas modifier normalement
	*/
	public function change_pwd_form() {
		$contenu = $this->form->create(array("fname"=>"add_ed_form","action"=>"/utilisateur/change_pwd","class"=>"mt20","button"=>"Changer le mot de passe"))
			->grid(3)
			->input(array("type"=>"password","name"=>"old_password","label"=>"Saisir votre ancien mot de passe","valeur"=>"","validate"=>array("type"=>"required")))
			->input(array("type"=>"password","name"=>"new_password","label"=>"Saisir votre nouveau mot de passe","valeur"=>"","validate"=>array("type"=>"required")))
			->input(array("type"=>"password","name"=>"confirm_new_password","label"=>"Confirmer votre nouveau mot de passe","valeur"=>"","validate"=>array("type"=>"required")))
			->render()
		;		
		echo $contenu;
	}

	public function change_pwd() {
		$req = "SELECT password FROM utilisateur WHERE `username` = '".$_SESSION['username']."'";
		$a_res =  $this->db_default->query($req)->result_array();
		$old_password_bdd = $a_res[0]['password'];

		if($old_password_bdd != md5($_POST['old_password'])) {
			$msg .= "Erreur : Votre ancien mot de passe ne correspond pas<br>";
		}
		if(strlen($_POST['new_password']) < 4) {
			$msg .= "Erreur : Le nouveau mot de passe doit contenir au moins 4 caractères<br>";	
		}
		if($_POST['new_password'] != $_POST['confirm_new_password']) {
			$msg .= "Erreur : Le nouveau mot de passe et la confirmation du mot de passe ne correspondent pas<br>";
		}

		if($msg=="") {
			$req = "UPDATE utilisateur SET password='".md5($_POST['new_password'])."' WHERE `username` = '".$_SESSION['idrh']."'";
			$a_res =  $this->db_default->query($req);
			echo alert("success","Votre mot de passe a été modifié",$timeout=5000); 
			echo javascript("mpClose()");
		}
		else {
			echo '<div class="alert alert-danger">'.$msg.'</div>';
		}
	}
	
	public function connexion() {
     	$req = "
     		SELECT 
     			utilisateur.*
     		FROM `utilisateur`
     		WHERE 
     			1 
     				AND `username` = '".$_POST['username']."'
     				AND `password` = '".md5($_POST['pwd'])."'
     		LIMIT 1

     	";
     	$a_res = $this->db->query($req)->result_array();
     	if(is_array($a_res)) {
     		if(count($a_res)==1) {
     			$_SESSION['username'] = $_POST['username'];
     			$_SESSION['id_utilisateur'] = $a_res[0]['id'];
     			$_SESSION['nom'] = $a_res[0]['realname'];
     			$_SESSION['email'] = $a_res[0]['email'];
     			$_SESSION['equipe'] = $a_res[0]['nom_equipe'];
     			$_SESSION['id_equipe'] = $a_res[0]['id_equipe'];
     			if(is_serialized($a_res[0]['role'])) {
     				$_SESSION['role'] = unserialize($a_res[0]['role']);
     			}
     			$this->load->helper('cookie');
     			foreach ($_SESSION as $key => $value) {
     				if($key != 'role') {
     					set_cookie($key,$value,60*60*24*30);	
     				}
     			}
     			set_cookie('role',$a_res[0]['role'],60*60*24*30); // on met le role sérialisé car l'array ne fonctionne pas
     			echo reload();
     		}
     		else {
     			echo alert('danger','Utilisateur ou mot de passe incorrect');
     		}
     	}
     	else {
     		
     	}
	}

	public function change_team_form(){
		$req = "SELECT * FROM pm_equipe";
		$a_res = $this->db->query($req)->result_array();
		$contenu .= '<h2>Cliquer sur le nom de l\'équipe que vous voulez mettre</h2>';
		foreach ($a_res as $key => $value) {
			if($value['id'] != $_SESSION['id_equipe'])
				$contenu .= jqHref("team_change_".$value['id'],"/utilisateur/add_ed_change_team","id_equipe=".$value['id']."&equipe=".$value['nom'],$value['nom'],"btn btn-warning btn-xs","glyphicon glyphicon-briefcase",$value['nom'],false,"jquerize","");
		}
		echo $contenu;
	}

	public function add_ed_change_team() {
		$this->load->helper('cookie');
		delete_cookie('id_equipe');
		delete_cookie('equipe');
		set_cookie('equipe',$_POST['id_equipe'],60*60*24*30);
		set_cookie('equipe',$_POST['equipe'],60*60*24*30);
		$_SESSION['id_equipe']=$_POST['id_equipe'];
		$_SESSION['equipe']=$_POST['equipe'];
		update(array("id_equipe"=>$_POST['id_equipe']),"utilisateur"," AND id = '".$_SESSION['id_utilisateur']."'",$exept=array(),$debug=false);
		echo '<div class="alert alert-success">Patientez pendant le chargement de la page</div>';
		echo reload();

	}

	public function logout() {
		$this->load->helper('cookie');
		session_unset();
		delete_cookie('username');
		delete_cookie('id_utilisateur');
		delete_cookie('nom');
		delete_cookie('email');
		delete_cookie('equipe');
		delete_cookie('id_equipe');
		delete_cookie('role');
		echo redirect('/');
	}

} 
?>