<?php
session_start();
//-------------------------------------------------------------------------#
// connexion automatique
//-------------------------------------------------------------------------#

function menu_code() {
    $contenu .= '
        <div class="dropdown fleft">
          <button class="btn btn-default dropdown-toggle" type="button" id="dropdownMenu1" data-toggle="dropdown" aria-haspopup="true" aria-expanded="true">
            <i class="glyphicon glyphicon-cog"></i>
            <span class="caret"></span>
          </button>
          <ul class="dropdown-menu" aria-labelledby="dropdownMenu1">
            <li><a href="/code">Accueil Code</a></li>
            <li role="separator" class="divider"></li>
            <li><a href="/code_categorie">Gérer les categories</a></li>
          </ul>
          &nbsp;
        </div>
    ';
    return $contenu ;
}

function menu_budget() {
    $contenu .= '
        <div class="dropdown fleft">
          <button class="btn btn-default dropdown-toggle" type="button" id="dropdownMenu1" data-toggle="dropdown" aria-haspopup="true" aria-expanded="true">
            <i class="glyphicon glyphicon-cog"></i>
            <span class="caret"></span>
          </button>
          <ul class="dropdown-menu" aria-labelledby="dropdownMenu1">
            <li><a href="/dates">Gérer les budgets</a></li>
            <li role="separator" class="divider"></li>
            <li><a href="/items">Gerer les libellés</a></li>
            <li role="separator" class="divider"></li>
            <li><a href="/categories">Gerer les catégories</a></li>
          </ul>
          &nbsp;
        </div>
    ';
    return $contenu ;
}

function connect_auto() {
    $CI =& get_instance();

    if(!$_SESSION['username']) {
        if($_COOKIE['username']) {
            $_SESSION['username'] = $_COOKIE['username'];
            $_SESSION['id_utilisateur'] = $_COOKIE['id_utilisateur'];
            $_SESSION['nom'] = $_COOKIE['nom'];
            $_SESSION['email'] = $_COOKIE['email'];
            $_SESSION['equipe'] = $_COOKIE['equipe'];
            $_SESSION['id_equipe'] = $_COOKIE['id_equipe'];
            $_SESSION['role'] = unserialize($_COOKIE['role']);
        }
    } 
    else {
        if(!$_SESSION['id_equipe']) {
            $CI->load->helper('cookie');
            session_unset();
            delete_cookie('username');
            delete_cookie('id_utilisateur');
            delete_cookie('nom');
            delete_cookie('email');
            delete_cookie('equipe');
            delete_cookie('id_equipe');
            delete_cookie('role');
            echo redirect('/'.portail);
        }
    }
}

function clickable_link($url) {
  return preg_replace('@(https?://([-\w\.]+[-\w])+(:\d+)?(/([\w/_\.#-]*(\?\S+)?[^\.\s])?)?)@', '<a href="$1" target="_blank">$1</a>', $url);
}

function nl2br_array($array) {
    foreach ($array as $key => $value) {
        foreach ($value as $key_2 => $value_2) {
            $array[$key][$key_2] = str_replace("0000-00-00 00:00:00","Non renseignée",nl2br($value_2));
        }
    }
    return $array;
}

function remove_quote_deb_fin($a) {
    $a = preg_replace("`^'`","",$a);
    $a = preg_replace("`'$`","",$a);
    return $a;
}

function where_creator($req, $pattern, $a_unset=array()) {
    $get_field_req=get_field_req($req,$a_unset);
    $a = $get_field_req['a_num_col'];
    if(is_array($a)) {
        $where = " AND (";
        $i=0;
        $nb=count($a)-1;
        foreach ($a as $key => $value) {
            if($i!=$nb)
                $s=" OR ";
            else 
                $s="";
            $where .= $value." LIKE '%".$pattern."%' ".$s;
            $i++;
        }
        $where .= ")";
    }
    return $where;
}

function get_field_req($req,$a_unset=array(),$a_add=array()){
    $a = explode(",",preg_replace("`SELECT(.*)FROM.*`","$1",str_replace ("\n","", trim($req))));
    foreach ($a as $key => $value) {
        $t = explode("as",$value);
        
        if(!in_array(trim($t[0]),$a_unset)) {
            $a_num_col[$key] = remove_quote_deb_fin(trim($t[0]));
            $a_title_col[$key] = remove_quote_deb_fin(trim($t[1]));
            $a_cor_col[trim($t[0])] = remove_quote_deb_fin(trim($t[1]));
        }
    }
    $i=$key+1;
    foreach ($a_add as $key => $value) {
        $a_title_col[$i] = $value;
        $i++;
    }
    return array(
        'a_num_col' => array_values($a_num_col),
        'a_title_col' => array_values($a_title_col),
        'a_cor_col' => $a_cor_col
    );
}

function get_dir_now() {
    $contenu = basename(dirname(dirname(dirname(__FILE__))));
    return $contenu;
}

function unserialize_64($serialized) {
    $a = unserialize(base64_decode($serialized));
    return $a;
}

function d($v){
    $_SESSION['d']=$v;
}

function export_to_csv($a_res,$filename="export_csv", $separator=";") {
    if(count($a_res)!=0) {
        header("Content-type: text/csv");
        header("Content-Disposition: attachment; filename=$filename.csv");
        header("Pragma: no-cache");
        header("Expires: 0");
    
        $outputBuffer = fopen("php://output", 'w');
        fputcsv($outputBuffer, array_keys($a_res[0]), $separator);
        foreach($a_res as $val) {
            fputcsv($outputBuffer, $val, $separator);
        }
        fclose($outputBuffer);
    }
    else {
        echo "Aucune donnée à exporter";
    }
}

function serialize_64($a) {
    $serialized = base64_encode(serialize($a));
    return $serialized;
}

function get_array_table($table,$col=array("nom","id"),$order="id",$where="") {
    $CI =& get_instance();
    $req = "SELECT * FROM `".$table."` WHERE 1 ".$where." ORDER BY ".$order." ASC";
    $a_res = $CI->db->query($req)->result_array();
    foreach ($a_res as $key => $value) {
        $a[$value[$col[0]]] = $value[$col[1]];
    }
    return $a;
}

function get_param_config($filename,$all="") {
    $contenu_du_fichier = unserialize(implode("",file(base_path."/rep_config/".$filename.".txt")));
    if($all)
        return $contenu_du_fichier;
    else
        return $contenu_du_fichier['valeur'];
}

function getNameFromNumber($num) {
    $numeric = $num % 26;
    $letter = chr(65 + $numeric);
    $num2 = intval($num / 26);
    if ($num2 > 0) {
        return getNameFromNumber($num2 - 1) . $letter;
    } else {
        return $letter;
    }
}

function cellCollor($obj,$cells,$color) {
    $obj->getStyle($cells)->getFill()->applyFromArray(array(
        'type' => PHPExcel_Style_Fill::FILL_SOLID,
        'startcolor' => array(
             'rgb' => $color
        )
    ));    
}

function fo_trigramme_session() {
    return get_param_config('idrh_tri');
}

function fo_trigramme_prenom() {
    return get_param_config('idrh_tri');
}

function liste_uo_sop(){
    $liste_uo_sop = get_param_config('uo_vp_autorized_in_sop');
    return $liste_uo_sop;
}

function liste_uo($inverse=false){
    $liste_uo = get_param_config('uo_vp_sop');
    if($inverse == false) 
        return $liste_uo;
    else
        return array_flip($liste_uo);
}

function base_path() {
    return dirname(BASEPATH);
}

function form_hidden($a_hidden,$debug="false"){
    $contenu .= '<form id="f_search_hidden">';
    foreach ($a_hidden as $key => $value) {
        if($debug == false)
            $contenu .= ''.$key.' : <input type="text" id="'.$key.'" name="'.$key.'" value="'.$value.'">';
        else
            $contenu .= '<input type="hidden"  id="'.$key.'" name="'.$key.'" value="'.$value.'">';
    }
    $contenu .= '</form>';    
    return $contenu;
}

function merge_array($array_1,$array_2) {
    $i=0;
    foreach ($array_1 as $key => $value) {
        $a[$value] = $array_2[$i];
        $i++;
    }
    return $a;
}

function csv_to_array($filename) {
    $a_data = array_map(function($d) {
    return str_getcsv($d, ";");
    }, file($filename));

    $i=0;
    foreach ($a_data as $key => $a_value) {
        foreach ($a_value as $key_2 => $value) {
            $a[$i][] = $value;
        }
        $i++;
    }
    return $a;
}

function listFileRep($dirname,$ext=array()){
    $dir = opendir($dirname); 
    while($file = readdir($dir)) {
        $ext_tmp=strtolower(strrchr($file,'.'));
        if($file != '.' && $file != '..') {
            if(in_array($ext_tmp,$ext)) {
                $contenu[]=$file;
            }
        }
    }
    closedir($dir);
    return $contenu;
}

function is_ajax() {
    if (strtolower(filter_input(INPUT_SERVER, 'HTTP_X_REQUESTED_WITH')) === 'xmlhttprequest')
        return true;
}


function alert($type,$msg,$timeout=5000) {
    return javascript("alertMe('".$type."','".addslashes($msg)."','".$timeout."')");
}

function in_array_all($needles, $haystack) {
    if(is_array($needles) && is_array($haystack))
        return !array_diff($needles, $haystack);
    else
        return false;
}

function in_array_any($needles, $haystack) {
    if(is_array($needles) && is_array($haystack))
        return !!array_intersect($needles, $haystack);
    else
        return false;
}

function get_role($a_role = array()) {
    if(is_array($a_role)) {
        $a_role[]=99; // ajout de l'administrateur
        array_unique($a_role);
        if($a_role == 0) {
            if(!is_array($_SESSION['role'])) {
                session_unset();
                return false;
            }
            else {
                return true;
            }
        }
        else {
            if(in_array_any($_SESSION['role'],$a_role)) {
                return true;
            }
            else {
                return false;
            }
        }
    }
    else {
        return false;
    }
}


function date_begin_last_day_mounth($m,$a) {
    return array(
        'debut'=>$a."-".$m."-01",
        'fin' => date("Y-m-t",strtotime($a."-".$m."-01"))
    );
}

function diff_date($deb,$fin) {
    $datetime1 = new DateTime($deb);
    $datetime2 = new DateTime($fin);
    $interval = $datetime1->diff($datetime2);
    return $interval->format('%R%a');   
}


function date_mois_fr($mois) {
    $mois = preg_replace("`^0([0-9])`","$1",$mois);
    $a_mois_fr = array(
        '1'=>'janvier',
        '2'=>'février',
        '3'=>'mars',
        '4'=>'avril',
        '5'=>'mai',
        '6'=>'juin',
        '7'=>'juillet',
        '8'=>'aout',
        '9'=>'septembre',
        '10'=>'octobre',
        '11'=>'novembre',
        '12'=>'décembre',
    );
    return $a_mois_fr[$mois];
}

function build_empty_table($a,$id,$class="",$option="") {
    $contenu .= '<table id="'.$id.'" class="'.$class.'" '.$option.'>
        <thead>
            <tr>
    ';
    foreach ($a as $key => $value) {
        $contenu .= '<th>'.stripslashes($value).'</th>';
    }
    $contenu .= ' 
            </tr>
        </thead>
        <tbody>
        </tbody>
    </table>
    ';
    return $contenu;
}

function build_table_v2($a_opt=array()){
    // changer en variable le contenu de l'array $a_opt
    foreach ($a_opt as $key => $value)
        ${$key} = $value;

    //les valeurs par défaut
    if(!$datatable) $datatable="datatable";
    if(!$date_convert) $date_convert = 'y';
    if(!is_array($a_unset)) $a_unset = array();

    if(!is_array($array) or count($array) == 0) {
        return 'Aucun résultat';
    }
    else {
        $i=0;
        foreach ($array as $key => $value) {
            foreach ($value as $key2 => $value2) {
                if(in_array($key2,$a_unset)) {
                    unset($array[$i][$key2]);
                }
            }
            $i++;
        }

        // start table
        $html = '<table id="'.$id.'" class="'.$datatable.' table table-bordered table-striped table-hover">';
        // header row
        $html .= '<thead>';
        $html .= '<tr>';
        foreach($array[0] as $key=>$value){
                $html .= '<th>' . $key . '</th>';
            }
        $html .= '</tr>';
        $html .= '</thead>';
        // data rows
        foreach( $array as $key=>$value){
            $html .= '<tr>';
            foreach($value as $key2=>$value2){
                if($date_convert == "y") {
                    if(preg_match("`^[0-9]{4}\-[0-9]{2}\-[0-9]{2}$`",$value2)) {
                        $value2 = preg_replace("`^([0-9]{4})\-([0-9]{2})\-([0-9]{2})$`","$3-$2-$1",$value2);
                    }
                }
                $html .= '<td>' . $value2 . '</td>';
            }
            $html .= '</tr>';
        }
        // finish table and return it
        $html .= '</table>';
        return $html;
    }
}

function add_col($array,$a_add=array()) {
    if(is_array($a_add)) {
        $i=0;
        foreach ($array as $key => $value) {
            foreach ($a_add as $key2 => $value2) {
                $array[$i][$key2] = $value2;
            }            
            $i++;
        }
    }
    return $array; 
}

function unset_col($array,$a_unset=array()) {
    $i=0;
    foreach ($array as $key => $value) {
        foreach ($value as $key2 => $value2) {
            if(in_array($key2,$a_unset)) {
                unset($array[$i][$key2]);
            }
        }
        $i++;
    }
    return $array;
}

function build_table($array,$id="",$a_unset=array(),$datatable="datatable"){
    
    if(!is_array($array) or count($array) == 0) {
        return 'Aucun résultat';
    }
    else {
        $i=0;
        foreach ($array as $key => $value) {
            foreach ($value as $key2 => $value2) {
                if(in_array($key2,$a_unset)) {
                    unset($array[$i][$key2]);
                }
            }
            $i++;
        }

        // start table
        $html = '<table id="'.$id.'" class="'.$datatable.' table table-bordered table-striped table-hover">';
        // header row
        $html .= '<thead>';
        $html .= '<tr>';
        foreach($array[0] as $key=>$value){
                $html .= '<th>' . $key . '</th>';
            }
        $html .= '</tr>';
        $html .= '</thead>';
        // data rows
        foreach( $array as $key=>$value){
            $html .= '<tr>';
            foreach($value as $key2=>$value2){
                if(preg_match("`^[0-9]{4}\-[0-9]{2}\-[0-9]{2}$`",$value2)) {
                    $value2 = preg_replace("`^([0-9]{4})\-([0-9]{2})\-([0-9]{2})$`","$3-$2-$1",$value2);
                    if($value2 == "01-01-1970")
                        $value2 = "";
                }
                $html .= '<td>' . $value2 . '</td>';
            }
            $html .= '</tr>';
        }
        // finish table and return it
        $html .= '</table>';
        return $html;
    }
}

function ckeditor($id_ck_editor,$url,$get_role){ 
    if (get_role(array($get_role))) {
        $contenu .= '
            <script src="'.base_url.'/plugins/ckeditor/ckeditor.js"></script>
            <script src="'.base_url.'/plugins/ckeditor/adapters/jquery.js"></script>
     
            <script> 
                $(document).ready(function(){          
                    $("'.$id_ck_editor.'").ckeditor({
                        entities : false,
                        extraPlugins : "autogrow,filebrowser,codesnippet,htmlbuttons",
                        allowedContent : true,
                        contentsCss : "'.base_url.'/plugins/bootstrap/css/bootstrap.min.css",
                        filebrowserBrowseUrl : "'.base_url.'/plugins/filemanager/filemanager/dialog.php?type=2&editor=ckeditor&fldr=", 
                        filebrowserUploadUrl : "'.base_url.'/plugins/filemanager/filemanager/dialog.php?type=2&editor=ckeditor&fldr=", 
                        filebrowserImageBrowseUrl : "'.base_url.'/plugins/filemanager/filemanager/dialog.php?type=1&editor=ckeditor&fldr=",
                        toolbar:
                            [
                                [ "Cut", "Copy", "Paste", "PasteText", "PasteFromWord", "Undo", "Redo"  ],
                                [ "Find", "Replace", "-", "SelectAll", "-", "Scayt" ],
                                [ "Bold", "Italic", "Underline", "Strike", "Subscript", "Superscript", "-", "RemoveFormat" ],
                                [ "NumberedList", "BulletedList", "-", "Outdent", "Indent", "-", "Blockquote", "CreateDiv", "-", "JustifyLeft", "JustifyCenter", "JustifyRight", "JustifyBlock"],
                                "/",
                                [ "Link", "Unlink", "Anchor" ],
                                [ "Image", "Table", "HorizontalRule", "Smiley","codesnippet"],
                                [ "Styles", "Format", "Font", "FontSize" ],
                                [ "TextColor", "BGColor" ],
                                [ "Maximize", "ShowBlocks","CodeSnippet","h1","h2","h3","h4" ] 
                            ],
                        tabSpaces:4,
                        codeSnippet_languages : {
                            javascript: "JavaScript",
                            bash : "KSH",
                            php: "PHP",
                            sql: "SQL"
                        },
                        htmlbuttons: [
                            {
                                name:"h1",
                                icon:"h1.png",
                                html:"<h1>--</h1>",
                                title:"h1"
                            },
                            {
                                name:"h2",
                                icon:"h2.png",
                                html:"<h2>--</h2>",
                                title:"h2"
                            },
                            {
                                name:"h3",
                                icon:"h3.png",
                                html:"<h3>--</h3>",
                                title:"h3"
                            },
                            {
                                name:"h4",
                                icon:"h4.png",
                                html:"<h4>--</h4>",
                                title:"h4"
                            }
                        ]
                    })
                    $("'.$id_ck_editor.'").each(function () {
                        var id = $(this).attr("id");
                        var editor = CKEDITOR.instances[id];
                        editor.on("blur", function (event) {
                                id_article = $("#" + id).attr("data-id");
                                $.ajax({
                                    url: "'.base_url."/".$url.'",
                                    cache: false,
                                    type: "POST",
                                    data: "article=" + addslashes(event.editor.getData()) + "&id=" + id_article,
                                    beforeSend: function() {
                                        $("#l_" + id + "").fadeIn();
                                    },
                                    success: function(data) {
                                        $("#r_" + id + "").html(data).fadeIn("slow");
                                        $("#l_" + id + "").fadeOut();
                                        chargement();
                                    },
                                    error:function (argument) {
                                        alert("Une erreur s\'est produite");
                                    } 
                                });
                        });
                        editor.addCommand("h1command", {
                            exec : function(editor,data) {
                                insert_html_editor("base","<h1>Titre 1</h1>");
                            }
                        })
                        editor.addCommand("h2command", {
                            exec : function(editor,data) {
                                insert_html_editor("base","<h2>Titre 2</h2>");
                            }
                        }) 
                        editor.addCommand("phpCommand", {
                            exec : function(editor,data) {
                                insert_html_editor("base","<code class=\'language-php hljs\'>php</code>");
                            }
                        })
                        editor.setKeystroke( CKEDITOR.CTRL + CKEDITOR.SHIFT + 49 , "h1command" ); 
                        editor.setKeystroke( CKEDITOR.CTRL + CKEDITOR.SHIFT + 50 , "h2command" ); 
                        editor.setKeystroke( CKEDITOR.CTRL + 75  , "phpCommand" ); 
                    });
                });
            </script>
        ';
    }
    return $contenu;
}

function get_role_redirect($a_role = array()) {
    $a_role[]=99; // ajout de l'administrateur
    // echo "<pre>".print_r($_SESSION['role'],true)."</pre>";
    // echo "<pre>".print_r($a_role,true)."</pre>";
    if($a_role==0) {
        if(!is_array($_SESSION['role'])) {
            session_unset();
            if(is_ajax()) {
                echo redirect("/accesinterdit");
            }
            else {
                header("location:/accesinterdit");
            }
        }
    }
    else {
        if(!in_array_any($_SESSION['role'],$a_role)) {
            session_unset();
            if(is_ajax()) {
                echo redirect("/accesinterdit");
            }
            else {
                header("location:/accesinterdit");
            }
        }
    }
}

function is_serialized($value, &$result = null) {
    // Bit of a give away this one
    if (!is_string($value))
    {
        return false;
    }
    // Serialized false, return true. unserialize() returns false on an
    // invalid string or it could return false if the string is serialized
    // false, eliminate that possibility.
    if ($value === 'b:0;')
    {
        $result = false;
        return true;
    }
    $length = strlen($value);
    $end    = '';
    switch ($value[0])
    {
        case 's':
            if ($value[$length - 2] !== '"')
            {
                return false;
            }
        case 'b':
        case 'i':
        case 'd':
            // This looks odd but it is quicker than isset()ing
            $end .= ';';
        case 'a':
        case 'O':
            $end .= '}';
            if ($value[1] !== ':')
            {
                return false;
            }
            switch ($value[2])
            {
                case 0:
                case 1:
                case 2:
                case 3:
                case 4:
                case 5:
                case 6:
                case 7:
                case 8:
                case 9:
                break;
                default:
                    return false;
            }
        case 'N':
            $end .= ';';
            if ($value[$length - 1] !== $end[0])
            {
                return false;
            }
        break;
        default:
            return false;
    }
    if (($result = @unserialize($value)) === false)
    {
        $result = null;
        return false;
    }
    return true;
}

function menu($items) {
    $CI =& get_instance();
    $CI->load->library('multi_menu');
    $CI->multi_menu->set_items($items);
    $contenu .= '
        <nav class="navbar navbar-inverse navbar-fixed-top">
            <div class="container-fluid">
                <div class="navbar-header">
                    <button type="button" class="navbar-toggle collapsed" data-toggle="collapse" data-target="#navbar" aria-expanded="false">
                        <span class="sr-only">Toggle navigation</span>
                        <span class="icon-bar"></span>
                        <span class="icon-bar"></span>
                        <span class="icon-bar"></span>
                    </button>
                    <a class="navbar-brand" href="/">'.sitename.'</a>        
                </div>
            <div class="collapse navbar-collapse" id="navbar">
    ';
    $contenu .= $CI->multi_menu->render(array(
        'nav_tag_open'        => '<ul class="nav navbar-nav">',            
        'parentl1_tag_open'   => '<li class="dropdown">',
        'parentl1_anchor'     => '<a tabindex="0" data-toggle="dropdown" href="%s">%s<span class="caret"></span></a>',
        'parent_tag_open'     => '<li class="dropdown-submenu">',
        'parent_anchor'       => '<a href="%s" data-toggle="dropdown">%s</a>',
        'children_tag_open'   => '<ul class="dropdown-menu">'
    ));
    if(!$_SESSION['id_utilisateur']) {
        $contenu .= '
                        <form class="navbar-form navbar-left pull-right" role="search" onsubmit="return false;">
                            <div class="form-group">
                                <div class="input-group">
                                    <span class="input-group-addon"><i class="fa fa-user fa" aria-hidden="true"></i></span>
                                    <input type="text" class="form-control" name="username" id="username"  placeholder="Nom d\'utilisateur" style="width:110px;"/>
                                </div>
                                <div class="input-group">
                                    <span class="input-group-addon"><i class="fa fa-lock fa-lg" aria-hidden="true"></i></span>
                                    <input type="password" class="form-control" name="pwd" id="pwd"  placeholder="Mot de passe" style="width:130px;"/>
                                </div>                        
                            </div>
                            <button type="submit" class="btn btn-success" style="margin-top:2px;" onclick="connexion()"> <i class="glyphicon glyphicon-ok"></i>&nbsp;  Connexion <span id="l_connexion" style="display:none;"><img src="'.base_url.'/images/loading.gif"></span></button>
                            <div id="r_connexion"></div>
                        </form>
        ';
    }
    else {
        $btn .= jqHref("logout","".base_url."/utilisateur/logout","","Deconnexion","btn btn-danger btn-xs","glyphicon glyphicon-log-out","Deconnexion","Voulez-vous vraiment vous déconnecter ?","jquerize");
        $contenu .= '
            <div class="pull-right info-nom">
                <i class="glyphicon glyphicon-user"></i> '.$_SESSION['nom'].' '.$_SESSION['prenom'].' '.jqHref("change_pwd","/utilisateur/change_pwd_form","","","btn btn-xs btn-success tooltip_bottom","glyphicon glyphicon-lock","Changer votre mot de passe","","mp","Modifier votre mot de passe").$btn_change_team.$btn.'
            </div>
        ';
    }    
    $contenu .= '
            </div>
        </nav>
    ';
    echo $contenu;
}

// function get_menu($items,$class = 'nav navbar-nav') {
//     $html = '<ul class="'.$class.'">';
//     foreach($items as $key=>$value) {
//         if(array_key_exists('child',$value)) {
//             $classLi = 'class="dropdown"';  
//             $caretInside = 'class="dropdown-toggle" data-toggle="dropdown" role="button" aria-haspopup="true" aria-expanded="false"';
//             $caretOutside = '<span class="caret"></span>';
//         }
//         else {
//             $classLi = '';      
//             $caretInside = '';
//             $caretOutside = '';
//         }

//         if(is_numeric($value['role'])) 
//             $value['role'] = array($value['role']);
//         if(is_serialized($value['role']))
//             $value['role'] = unserialize($value['role']);

//         if(get_role($value['role']) or $value['role'] == "") {
//             if(preg_match("`^http`",$value['slug']))
//                 $url = $value['slug'];
//             else
//                 $url = base_url.'/'.$value['slug'];

//             $html.= '<li '.$classLi.' ><a href="'.$url.'" '.$caretInside.'>'.$value['label'].' '.$caretOutside.'</a>';
//         }

//         if(array_key_exists('child',$value)) {
//             $html .= get_menu($value['child'],'dropdown-menu');
//         }
//             $html .= "</li>";
//     }
//     $html .= "</ul>";
//     return $html;
// }

function msgModal($type,$message,$timeout=0) {
    return javascript('msgModal("'.$type.'","'.$message.'","'.$timeout.'")');
}

function query_oracle($req,$conn){
    if (!$conn) {
        $e = oci_error();
        trigger_error(htmlentities($e['message'], ENT_QUOTES), E_USER_ERROR);
    }
     
    $stid = oci_parse($conn, $req);
    oci_execute($stid);
    
    while ($row = oci_fetch_array($stid, OCI_ASSOC+OCI_RETURN_NULLS)) {
        $res[] = $row;
        // foreach ($row as $item) {
        //     $res[] = $row;
        // }
    }
    oci_close($conn);
    if(isset($res)) {
        return $res;
    }
}

function get_num_sem($date) {
    return date('W',date_to_mktime($date));
}

function trouver_date_semaine($semaine,$annee="") {
    $semaine = $semaine-1;
    $time = strtotime("1 January $annee", time());
    $day = date('w', $time);
    $time += ((7*$semaine)+1-$day)*24*3600;
    $return[0] = date('d/m/Y', $time);
    $time += 6*24*3600;
    $return[1] = date('d/m/Y', $time);
 

    return $return[0];
}

function trouver_date_semaine_($semaine,$annee="") {
    $semaine = '01';
    echo "<pre>".print_r($semaine,true)."</pre>";
    echo "<pre>".print_r($annee,true)."</pre>";
    $jour = 0;

    if(!$annee) $annee = date('Y');
    if(strftime("%W",mktime(0,0,0,01,01,$annee))==1)
    $mktime = mktime(0,0,0,01,(01+(($semaine-1)*7)),$annee);
    else
    $mktime = mktime(0,0,0,01,(01+(($semaine)*7)),$annee);
 
    if(date("w",$mktime) > 1)
    $decalage = ((date("w",$mktime)-1)*60*60*24);
  
    $lundi = $mktime - $decalage;
    $mardi = $lundi + (1*60*60*24);
    $mercredi = $lundi + (2*60*60*24);
    $jeudi = $lundi + (3*60*60*24);
    $vendredi = $lundi + (4*60*60*24);
    $samedi = $lundi + (5*60*60*24);
    $dimanche = $lundi + (6*60*60*24);
     
    $resultat = array(date("d/m/Y",$lundi),
              date("d/m/Y",$mardi),
              date("d/m/Y",$mercredi),
              date("d/m/Y",$jeudi),
              date("d/m/Y",$vendredi),
              date("d/m/Y",$samedi),
              date("d/m/Y",$dimanche));
    
    echo "<pre>".print_r($resultat,true)."</pre>";

    $jours = array(0, 1, 2, 3, 4, 5, 6);

    if(in_array($jour, $jours))
    // return $resultat[$jour];
    return '02/01/2017';
}

function convertir_mois_en_fr($mois_anglais) {
    $mois_anglais = strtolower($mois_anglais);
    $mois_francais = [
        'january' => 'janvier',
        'february' => 'février',
        'march' => 'mars',
        'april' => 'avril',
        'may' => 'mai',
        'june' => 'juin',
        'july' => 'juillet',
        'august' => 'août',
        'september' => 'septembre',
        'october' => 'octobre',
        'november' => 'novembre',
        'december' => 'décembre'
    ];
    return $mois_francais[$mois_anglais];
}

function date_to_mktime($date){
    if(preg_match("`^[0-9]{2}/[0-9]{2}/[0-9]{4}$`",$date)) {
        $a_date = explode("/",$date);
        return mktime(0,0,0,$a_date[1],$a_date[0],$a_date[2]);
    }
    //date mysql fr
    if(preg_match("`^[0-9]{2}-[0-9]{2}-[0-9]{4}$`",$date)) {
        $a_date = explode("-",$date);
        return mktime(0,0,0,$a_date[1],$a_date[0],$a_date[2]);
    } 
    //date mysql en
    if(preg_match("`^[0-9]{4}-[0-9]{2}-[0-9]{2}$`",$date)) {
        $a_date = explode("-",$date);
        // echo "<pre>".print_r($a_date,true)."</pre>";
        // echo mktime(0,0,0,$a_date[1],$a_date[2],$a_date[0]);
        return mktime(0,0,0,$a_date[1],$a_date[2],$a_date[0]);
    }    
    
}

function mktime_to_date($mktime) {
    return date("d/m/Y H:i:s");
}

function mktime_to_date_mysql($mktime) {
    return date("Y-m-d",$mktime);
}

function convert_to_date_mysql($date) {
    $date_en_tableau = explode('/', $date);
    $date_en_chaine = $date_en_tableau[2] . '-' . $date_en_tableau[1] . '-' . $date_en_tableau[0];
    return $date_en_chaine;
}


function msg($id,$type,$msg) {
    return javascript('msg("'.$id.'","'.$type.'","'.$msg.'")');    
}

function closeModal($timeout=0){
    if ($timeout==0) {
        echo javascript("$('#myModal').modal('hide')");    
    }
    else {
        echo javascript("setTimeout(function(){ $('#myModal').modal('hide') }, ".$timeout.");");
    }
}

function to_array($object_array) {
    if(is_object($object_array)) {
        $array = get_object_vars($object_array);
        return $array;
    }
}

function ulLi($list,$class="",$clear=true){
    if(is_array($list)) {
        $contenu .= '<ul class="'.$class.'">'."\n";
        $i=0;
        foreach ($list as $key => $value) {
            $contenu .= "\t".'<li>'."\n";
            $contenu .= "\t\t".$value;
            $contenu .= "\t".'</li>'."\n";
            $i++;
        }
        $contenu .= '</ul>'."\n";
    }
    if($clear==true) {
        $contenu .= '<div class="clear"></div>';
    }
    return $contenu;
}

function jqHref($fName,$act,$data,$texte,$class="",$i="",$title="",$confirm=false,$type="jquerize",$titre_modal="",$opt=array()){
    $confirm = addslashes($confirm);
    if(is_array($opt)) {
        foreach ($opt as $key => $value) {
            ${$key}=$value;
        }
    }
        
    if ($i) {
        $i_t=' <i class="'.$i.'"></i> ';
    }

    if ($mobileHide=="y") {
        $texte = ' <span class="mobileHide"> '.$texte.' </span> ';
    }

    if($type=="jquerize") {
        if ($class) {
            $class='class="'.$class.'"';
        }
    }

    if ($confirm) {
        $onClick = 'onclick="if(confirm(\''.$confirm.'\'))return true; else return false;"';
    }

    if($type=="jquerize") {
        $contenu .= '<a href="javascript:jquerize(\''.$fName.'\',\''.$act.'\',\''.$data.'\',\'\',\''.$search.'\')" '.$class.'  '.$optData.' '.$onClick.' >'.$i_t.' '.$texte.' '.res($fName).' </a>';
    }
    elseif($type=="mp") {
        $contenu .= link_modal($act,$data,$texte,$title,$titre_modal,$i,'class="'.$class.'"');
    }
    elseif($type=="mp_wide" or $type == "mpwide") {
        $contenu .= link_modal_wide($act,$data,$texte,$title,$titre_modal,$i,'class="'.$class.'"');
    }

    return $contenu;
}

function link_modal($url,$data,$texte,$title,$titre_modal,$i="",$option="") { 
    if($i) {
        $i = ' <i class="'.$i.'"></i> ';
    }
    $contenu=" <a href=\"javascript:mpU('".$url."','".$data."','". addslashes($titre_modal) . "')\" ".$option." title=\"".$title."\" > ".$i." ". $texte ."</a> ";
    return $contenu;
}

function link_modal_wide($url,$data,$texte,$title,$titre_modal,$i="",$option="") { 
    if($i) {
        $i = ' <i class="'.$i.'"></i> ';
    }
    $contenu=" <a href=\"javascript:mpU('".$url."','".$data."','".$titre_modal."','wide')\" ".$option." title=\"".$title."\" > ".$i." ".$texte."</a> ";
    return $contenu;
}

function imageLoading($f_name,$debug="no"){
    if($debug=="no") { $style='style="display:none;"'; }
    $contenu = '<span id="l_'.$f_name.'" '.$style.'><img src="'.base_url.'/images/loading.gif"></span>';
    return $contenu;
}

function res($fNameSansF,$debug="no"){
    $contenu = imageLoading($fNameSansF,$debug).'<span id="r_'.$fNameSansF.'"></span>';
    return $contenu;
}

function redirect($page,$alert_type="",$level="") {
    if(!$alert_type) {
        return javascript("document.location.href='".$page."'");
    }
    else {
        $contenu .= '
            mpClose();
            bootbox.alert("<style>.modal-content { '.level_color($level).' }</style>'.alert_type($alert_type).'", function() {
                window.location.href=\''.$page.'\';
            });
        ';
        return javascript($contenu);
    }
}

function reload($alert_type="",$level=""){
    if(!$alert_type) {
        return javascript('window.location.reload()');
    }
    else {
        $contenu .= '
            mpClose();
            bootbox.alert("<style>.modal-content { '.level_color($level).' }</style>'.alert_type($alert_type).'", function() {
                window.location.reload();
            });
        ';
        return javascript($contenu);
    }
}

function javascript_aff($string) {
    $string = addslashes($string);
    $string = str_replace(array("\r\n", "\n"), null, $string);
    return $string; 
}

function javascript($javascript) {
    $contenu = '
    <script language=\'javascript\'>
        '.$javascript.'
    </script>';
    return $contenu;
}
function date_fr($date_ori,$type="long:complete:approx:heure"){

    if(preg_match("`court`",$type)) {
        $mode = "court";
    }
    else {
        $mode = "long";
    }
    if(preg_match("`\d{10}`",$date_ori)) {
        //si c'est un format timestamp on ne fait rien
    }
    elseif(preg_match("`^(0[1-9]|[1-2][0-9]|3[0-1])\/(0[1-9]|1[0-2])\/[0-9]{4}$`",$date_ori)) {
        echo "<pre>".print_r("ici",true)."</pre>";
        //si c'est un format 03/11/2007
        $t = explode("/", $date_ori);
        $date_ori = mktime(0,0,0,$t[1],$t[0],$t[2]);
    }
    elseif(preg_match("`^\d{4}/\d{2}/\d{2}$`",$date_ori)) {
        //si c'est un format 2007/11/03
        $t = explode("/", $date_ori);
        $date_ori = mktime(0,0,0,$t[1],$t[2],$t[0]);
    }
    elseif(preg_match("`^\d{2}-\d{2}-\d{4}$`",$date_ori)) {
        //si c'est un format 2007-11-03
        $t = explode("-", $date_ori);
        $date_ori = mktime(0,0,0,$t[1],$t[0],$t[2]);
    }
    elseif(preg_match("`^\d{4}-\d{2}-\d{2}$`",$date_ori)) {
        //si c'est un format 2007-11-03
        $t = explode("-", $date_ori);
        $date_ori = mktime(0,0,0,$t[1],$t[2],$t[0]);
    }
    elseif(preg_match("`^\d{4}-\d{2}-\d{2} \d{2}:\d{2}:\d{2}$`",$date_ori)) {
        //si c'est un format 2007-11-03 15:21:20
        $t = explode(" ",$date_ori);
        $date = explode("-",$t[0]);
        $heure = explode(":",$t[1]);
        $date_ori = mktime($heure[0],$heure[1],$heure[2],$date[1],$date[2],$date[0]);
    }
    $date = getdate($date_ori);
    if ($mode == "court") {
        $jour[0]="Dim";$jour[1]="Lun";$jour[2]="Mar";$jour[3]="Mer";$jour[4]="Jeu";$jour[5]="Ven";$jour[6]="Sam";$mois[1]="jan";$mois[2]="fév";$mois[3]="mars";$mois[4]="avril";$mois[5]="mai";$mois[6]="juin";$mois[7]="juil";$mois[8]="aout";$mois[9]="sept";$mois[10]="oct";$mois[11]="nov";$mois[12]= "déc";
    }
    else {
        $jour[0]="Dimanche";$jour[1]="Lundi";$jour[2]="Mardi";$jour[3]="Mercredi";$jour[4]="Jeudi";$jour[5]="Vendredi";$jour[6]="Samedi";$mois[1]="janvier";$mois[2]="février";$mois[3]="mars";$mois[4]="avril";$mois[5]="mai";$mois[6]="juin";$mois[7]="juillet";$mois[8]="aout";$mois[9]="septembre";$mois[10]="octobre";$mois[11]="novembre";$mois[12]="décembre";
    }
    $sem_txt = $jour[$date['wday']];
    $j_num = date("d",$date_ori);
    $m_txt = $mois[$date['mon']];
    $m_num = date("m",$date_ori);
    $annee = date("Y",$date_ori);
    //-------------------------------------------------------------------------#
    // heure
    //-------------------------------------------------------------------------#
    $heure=date("H:i:s",$date_ori);
    //-------------------------------------------------------------------------#
    // Debut date exacte
    //-------------------------------------------------------------------------#
    if(preg_match("`heure`", $type)) {
        $heure_suite = " &agrave; ".$heure;
    }
    if(preg_match("`resume`", $type)) {
        $date_complete = date("d/m/Y",$date_ori);
    }
    else {
        $date_complete = $sem_txt." ".$j_num." ".$m_txt." ".$annee." ".$heure_suite;
    }
    //-------------------------------------------------------------------------#
    // Debut date approximatif
    //-------------------------------------------------------------------------#
    $now = time();
    $created = $date_ori;
    // La différence est en seconde
    $diff = $now-$created;
    $m = ($diff)/(60); // on obtient des minutes
    $h = ($diff)/(60*60); // ici des heures
    $j = ($diff)/(60*60*24); // jours
    $s = ($diff)/(60*60*24*7); // et semaines
    // echo error("created=".$created."<br>now=".$now."<br>m=".$m." h=".$h." j=".$j." s=".$s);
    if ($diff < 60) { // "il y a x secondes"
        $date_approx = 'Il y a '.$diff.' secondes';
    }
    elseif ($m < 60) { // "il y a x minutes"
        $minute = (floor($m) == 1) ? 'minute' : 'minutes';
        $date_approx = 'Il y a '.floor($m).' '.$minute;
    }
    elseif ($h < 24) { // " il y a x heures, x minutes"
        $heure = (floor($h) <= 1) ? 'heure' : 'heures';
        $dateFormated = 'Il y a '.floor($h).' '.$heure;
        if (floor($m-(floor($h))*60) != 0) {
            $minute = (floor($m) == 1) ? 'minute' : 'minutes';
            $dateFormated .= ', '.floor($m-(floor($h))*60).' '.$minute;
        }
        $date_approx = $dateFormated;
    }
    elseif ($j < 7) { // " il y a x jours, x heures"
        $jour = (floor($j) <= 1) ? 'jour' : 'jours';
        $dateFormated = 'Il y a '.floor($j).' '.$jour;
        if (floor($h-(floor($j))*24) != 0) {
            $heure = (floor($h) <= 1) ? 'heure' : 'heures';
            $dateFormated .= ', '.floor($h-(floor($j))*24).' '.$heure;
        }
        $date_approx = $dateFormated;
    }
    elseif ($s < 5) { // " il y a x semaines, x jours"
        $semaine = (floor($s) <= 1) ? 'semaine' : 'semaines';
        $dateFormated = 'Il y a '.floor($s).' '.$semaine;
        if (floor($j-(floor($s))*7) != 0) {
            $jour = (floor($j) <= 1) ? 'jour' : 'jours';
            $dateFormated .= ', '.floor($j-(floor($s))*7).' '.$jour;
        }
        $date_approx = $dateFormated;
    }
    else { // on affiche la date normalement
        if(!preg_match("`complete`",$type) && !preg_match("`resume`",$type) ) {
            $date_approx = $date_complete;
        }
    }
    //affichage
    if(preg_match("`complete`", $type) || preg_match("`resume`", $type)) {
        $contenu .= " ".$date_complete;
    }
    if(preg_match("`approx`", $type)) {
        $contenu .= " ".$date_approx;
    }   
    return trim($contenu);
}

function addslashes_array($array){
    foreach ($array as $key => $value) {
        $a[$key] = addslashes($value);
    }
    return $a;
}

function active($a,$b,$class_name_normal,$class_name_active) {
    if($a == $b) 
        $class = $class_name_active ;
    else 
        $class = $class_name_normal ;
    return $class ;
}

function pagination ($nb_total, $nb_affichage_par_page, $debut, $nb_liens_dans_la_barre, $url_rewrite, $url_rewrite_fin) {
    
    $barre = '';
    $barre = '<nav>';
    $barre .= '<ul class="pagination">';
    $query = $url_rewrite;
    $page_active = floor(($debut/$nb_affichage_par_page)+1);
    $nb_pages_total = ceil($nb_total/$nb_affichage_par_page);
    if ($nb_liens_dans_la_barre%2==0) {
        $cpt_deb1 = $page_active - ($nb_liens_dans_la_barre/2)+1;
        $cpt_fin1 = $page_active + ($nb_liens_dans_la_barre/2);
    }
    else {
        $cpt_deb1 = $page_active - floor(($nb_liens_dans_la_barre/2));
        $cpt_fin1 = $page_active + floor(($nb_liens_dans_la_barre/2));
    }
    
    if ($cpt_deb1 <= 1) {
        $cpt_deb = 1;
        $cpt_fin = $nb_liens_dans_la_barre;
    }
    elseif ($cpt_deb1>1 && $cpt_fin1<$nb_pages_total) {
        $cpt_deb = $cpt_deb1;
        $cpt_fin = $cpt_fin1;
    }
    else {
        $cpt_deb = ($nb_pages_total-$nb_liens_dans_la_barre)+1;
        $cpt_fin = $nb_pages_total;
    }

    if ($nb_pages_total <= $nb_liens_dans_la_barre) {
        $cpt_deb=1;
        $cpt_fin=$nb_pages_total;
    }
    if ($cpt_deb != 1) {
        $cible = $query.(0);
        $lien = '<li><a href="'.$cible.''.$url_rewrite_fin.'" aria-label="Previous"><i class="glyphicon glyphicon-backward"></i></a></li>';
    }
    else {
        $lien='';
    }
    $barre .= $lien;
    for ($cpt = $cpt_deb; $cpt <= $cpt_fin; $cpt++) {
        if ($cpt == $page_active) {
            if ($cpt == $nb_pages_total) {
                $barre .= '<li class="active"><a href="#">'.$cpt.'</a></li>';
            }
            else {
                $barre .= '<li class="active"><a href="#">'.$cpt.'</a></li>';
            }
            $page_actuelle = $cpt;
        }
        else {
            if ($cpt == $cpt_fin) {
                $barre .= '<li><a href="'.$query.(($cpt-1)*$nb_affichage_par_page).$url_rewrite_fin.'">'.$cpt.'</a></li>';                
            }
            else {  
                $barre .= '<li><a href="'.$query.(($cpt-1)*$nb_affichage_par_page).$url_rewrite_fin.'">'.$cpt.'</a></li>';
            }
        }
    }
    
    $fin = ($nb_total - ($nb_total % $nb_affichage_par_page));
    if (($nb_total % $nb_affichage_par_page) == 0) {
        $fin = $fin - $nb_affichage_par_page;
    }
    if ($cpt_fin != $nb_pages_total) {
        $cible = $query.$fin;
        $lien = '<li><a href="'.$cible.''.$url_rewrite_fin.'" aria-label="Next" ><i class="glyphicon glyphicon-forward"></i></a></li>';
    }
    else {
        $lien='';
    }
    $barre .= $lien;

    $barre .= '
        <li id="l_'.$f_name.'" style="display:none;">
            <a href="#">
                <img src="'.ctUrl.'/images/loading.gif"></span><span id="r_'.$f_name.'">
            </a>
        </li>
    ';
    $barre .= '</ul>';
    $barre .= res("l_pagination");
    $barre .= '</nav>';
    if ($nb_total+1 > $nb_affichage_par_page) {
        return $barre; 
    }
    else {
        return '<div class="mb20"></div>';
    }
}

function paginationAjax ($nb_total, $nb_affichage_par_page, $debut, $nb_liens_dans_la_barre,$url,$data,$fname="pagination") {
    $barre = '';
    $barre .= '<ul class="pagination">';
    // jquerize(f_name,url,f_data,res,search)
    $url = 'javascript:jquerize(\''.$fname.'\',\''.$url;
    $url_rewrite_fin = "','".$data."')";
    if(!preg_match("`/$`",$url))
        $query = $url."/";
    else 
        $query = $url;
    $page_active = floor(($debut/$nb_affichage_par_page)+1);
    $nb_pages_total = ceil($nb_total/$nb_affichage_par_page);
    if ($nb_liens_dans_la_barre%2==0) {
        $cpt_deb1 = $page_active - ($nb_liens_dans_la_barre/2)+1;
        $cpt_fin1 = $page_active + ($nb_liens_dans_la_barre/2);
    }
    else {
        $cpt_deb1 = $page_active - floor(($nb_liens_dans_la_barre/2));
        $cpt_fin1 = $page_active + floor(($nb_liens_dans_la_barre/2));
    }
    
    if ($cpt_deb1 <= 1) {
        $cpt_deb = 1;
        $cpt_fin = $nb_liens_dans_la_barre;
    }
    elseif ($cpt_deb1>1 && $cpt_fin1<$nb_pages_total) {
        $cpt_deb = $cpt_deb1;
        $cpt_fin = $cpt_fin1;
    }
    else {
        $cpt_deb = ($nb_pages_total-$nb_liens_dans_la_barre)+1;
        $cpt_fin = $nb_pages_total;
    }

    if ($nb_pages_total <= $nb_liens_dans_la_barre) {
        $cpt_deb=1;
        $cpt_fin=$nb_pages_total;
    }
    if ($cpt_deb != 1) {
        $cible = $query.(0);
        $lien = '<li><a href="'.$cible.''.$url_rewrite_fin.'" aria-label="Previous"><i class="glyphicon glyphicon-backward"></i></a></li>';
    }
    else {
        $lien='';
    }
    $barre .= $lien;
    for ($cpt = $cpt_deb; $cpt <= $cpt_fin; $cpt++) {
        if ($cpt == $page_active) {
            if ($cpt == $nb_pages_total) {
                $barre .= '<li class="active"><a href="#">'.$cpt.'</a></li>';
            }
            else {
                $barre .= '<li class="active"><a href="#">'.$cpt.'</a></li>';
            }
            $page_actuelle = $cpt;
        }
        else {
            if ($cpt == $cpt_fin) {
                $barre .= '<li><a href="'.$query.(($cpt-1)*$nb_affichage_par_page).$url_rewrite_fin.'">'.$cpt.'</a></li>';                
            }
            else {  
                $barre .= '<li><a href="'.$query.(($cpt-1)*$nb_affichage_par_page).$url_rewrite_fin.'">'.$cpt.'</a></li>';
            }
        }
    }
    
    $fin = ($nb_total - ($nb_total % $nb_affichage_par_page));
    if (($nb_total % $nb_affichage_par_page) == 0) {
        $fin = $fin - $nb_affichage_par_page;
    }
    if ($cpt_fin != $nb_pages_total) {
        $cible = $query.$fin;
        $lien = '<li><a href="'.$cible.''.$url_rewrite_fin.'" aria-label="Next" ><i class="glyphicon glyphicon-forward"></i></a></li>';
    }
    else {
        $lien='';
    }
    $barre .= $lien;

    $barre .= '
        <li id="l_'.$f_name.'" style="display:none;">
            <a href="#">
                <img src="/images/loading.gif"></span><span id="r_'.$f_name.'">
            </a>
        </li>
    ';
    $barre .= '</ul>';
    $barre .= res("l_pagination");
    if ($nb_total+1 > $nb_affichage_par_page) {
        return $barre; 
    }
}

function transliterateString($txt) {
    $transliterationTable = array('á' => 'a', 'Á' => 'A', 'à' => 'a', 'À' => 'A', 'ă' => 'a', 'Ă' => 'A', 'â' => 'a', 'Â' => 'A', 'å' => 'a', 'Å' => 'A', 'ã' => 'a', 'Ã' => 'A', 'ą' => 'a', 'Ą' => 'A', 'ā' => 'a', 'Ā' => 'A', 'ä' => 'ae', 'Ä' => 'AE', 'æ' => 'ae', 'Æ' => 'AE', 'ḃ' => 'b', 'Ḃ' => 'B', 'ć' => 'c', 'Ć' => 'C', 'ĉ' => 'c', 'Ĉ' => 'C', 'č' => 'c', 'Č' => 'C', 'ċ' => 'c', 'Ċ' => 'C', 'ç' => 'c', 'Ç' => 'C', 'ď' => 'd', 'Ď' => 'D', 'ḋ' => 'd', 'Ḋ' => 'D', 'đ' => 'd', 'Đ' => 'D', 'ð' => 'dh', 'Ð' => 'Dh', 'é' => 'e', 'É' => 'E', 'è' => 'e', 'È' => 'E', 'ĕ' => 'e', 'Ĕ' => 'E', 'ê' => 'e', 'Ê' => 'E', 'ě' => 'e', 'Ě' => 'E', 'ë' => 'e', 'Ë' => 'E', 'ė' => 'e', 'Ė' => 'E', 'ę' => 'e', 'Ę' => 'E', 'ē' => 'e', 'Ē' => 'E', 'ḟ' => 'f', 'Ḟ' => 'F', 'ƒ' => 'f', 'Ƒ' => 'F', 'ğ' => 'g', 'Ğ' => 'G', 'ĝ' => 'g', 'Ĝ' => 'G', 'ġ' => 'g', 'Ġ' => 'G', 'ģ' => 'g', 'Ģ' => 'G', 'ĥ' => 'h', 'Ĥ' => 'H', 'ħ' => 'h', 'Ħ' => 'H', 'í' => 'i', 'Í' => 'I', 'ì' => 'i', 'Ì' => 'I', 'î' => 'i', 'Î' => 'I', 'ï' => 'i', 'Ï' => 'I', 'ĩ' => 'i', 'Ĩ' => 'I', 'į' => 'i', 'Į' => 'I', 'ī' => 'i', 'Ī' => 'I', 'ĵ' => 'j', 'Ĵ' => 'J', 'ķ' => 'k', 'Ķ' => 'K', 'ĺ' => 'l', 'Ĺ' => 'L', 'ľ' => 'l', 'Ľ' => 'L', 'ļ' => 'l', 'Ļ' => 'L', 'ł' => 'l', 'Ł' => 'L', 'ṁ' => 'm', 'Ṁ' => 'M', 'ń' => 'n', 'Ń' => 'N', 'ň' => 'n', 'Ň' => 'N', 'ñ' => 'n', 'Ñ' => 'N', 'ņ' => 'n', 'Ņ' => 'N', 'ó' => 'o', 'Ó' => 'O', 'ò' => 'o', 'Ò' => 'O', 'ô' => 'o', 'Ô' => 'O', 'ő' => 'o', 'Ő' => 'O', 'õ' => 'o', 'Õ' => 'O', 'ø' => 'oe', 'Ø' => 'OE', 'ō' => 'o', 'Ō' => 'O', 'ơ' => 'o', 'Ơ' => 'O', 'ö' => 'oe', 'Ö' => 'OE', 'ṗ' => 'p', 'Ṗ' => 'P', 'ŕ' => 'r', 'Ŕ' => 'R', 'ř' => 'r', 'Ř' => 'R', 'ŗ' => 'r', 'Ŗ' => 'R', 'ś' => 's', 'Ś' => 'S', 'ŝ' => 's', 'Ŝ' => 'S', 'š' => 's', 'Š' => 'S', 'ṡ' => 's', 'Ṡ' => 'S', 'ş' => 's', 'Ş' => 'S', 'ș' => 's', 'Ș' => 'S', 'ß' => 'SS', 'ť' => 't', 'Ť' => 'T', 'ṫ' => 't', 'Ṫ' => 'T', 'ţ' => 't', 'Ţ' => 'T', 'ț' => 't', 'Ț' => 'T', 'ŧ' => 't', 'Ŧ' => 'T', 'ú' => 'u', 'Ú' => 'U', 'ù' => 'u', 'Ù' => 'U', 'ŭ' => 'u', 'Ŭ' => 'U', 'û' => 'u', 'Û' => 'U', 'ů' => 'u', 'Ů' => 'U', 'ű' => 'u', 'Ű' => 'U', 'ũ' => 'u', 'Ũ' => 'U', 'ų' => 'u', 'Ų' => 'U', 'ū' => 'u', 'Ū' => 'U', 'ư' => 'u', 'Ư' => 'U', 'ü' => 'ue', 'Ü' => 'UE', 'ẃ' => 'w', 'Ẃ' => 'W', 'ẁ' => 'w', 'Ẁ' => 'W', 'ŵ' => 'w', 'Ŵ' => 'W', 'ẅ' => 'w', 'Ẅ' => 'W', 'ý' => 'y', 'Ý' => 'Y', 'ỳ' => 'y', 'Ỳ' => 'Y', 'ŷ' => 'y', 'Ŷ' => 'Y', 'ÿ' => 'y', 'Ÿ' => 'Y', 'ź' => 'z', 'Ź' => 'Z', 'ž' => 'z', 'Ž' => 'Z', 'ż' => 'z', 'Ż' => 'Z', 'þ' => 'th', 'Þ' => 'Th', 'µ' => 'u', 'а' => 'a', 'А' => 'a', 'б' => 'b', 'Б' => 'b', 'в' => 'v', 'В' => 'v', 'г' => 'g', 'Г' => 'g', 'д' => 'd', 'Д' => 'd', 'е' => 'e', 'Е' => 'E', 'ё' => 'e', 'Ё' => 'E', 'ж' => 'zh', 'Ж' => 'zh', 'з' => 'z', 'З' => 'z', 'и' => 'i', 'И' => 'i', 'й' => 'j', 'Й' => 'j', 'к' => 'k', 'К' => 'k', 'л' => 'l', 'Л' => 'l', 'м' => 'm', 'М' => 'm', 'н' => 'n', 'Н' => 'n', 'о' => 'o', 'О' => 'o', 'п' => 'p', 'П' => 'p', 'р' => 'r', 'Р' => 'r', 'с' => 's', 'С' => 's', 'т' => 't', 'Т' => 't', 'у' => 'u', 'У' => 'u', 'ф' => 'f', 'Ф' => 'f', 'х' => 'h', 'Х' => 'h', 'ц' => 'c', 'Ц' => 'c', 'ч' => 'ch', 'Ч' => 'ch', 'ш' => 'sh', 'Ш' => 'sh', 'щ' => 'sch', 'Щ' => 'sch', 'ъ' => '', 'Ъ' => '', 'ы' => 'y', 'Ы' => 'y', 'ь' => '', 'Ь' => '', 'э' => 'e', 'Э' => 'e', 'ю' => 'ju', 'Ю' => 'ju', 'я' => 'ja', 'Я' => 'ja');
    return str_replace(array_keys($transliterationTable), array_values($transliterationTable), $txt);
}

function removechars($string) {
    if($string) {
        $string = transliterateString($string); 
        $string=str_replace("(","_",$string);
        $string=str_replace(")","_",$string);
        $string=str_replace(" ","_",$string);
        $string=str_replace("'","_",$string);
        $string=str_replace("-","_",$string);
        $string=strtolower($string);
        $authorised="abcdefghijklmnopqrstuvwxyz0123456789_";
        $string = trim($string); 
        for ($i = 0; $i < strlen($string); $i++) { 
            $table[$i] = substr($string,$i,1); 
        } #for 
        while (list ($line_num, $line) = each ($table)) { 
            if ($line_num < strlen($string)) {
                $pos = strpos($authorised,$line);
            } 
            if (strlen($pos) == 0) {
                $table[$line_num] = "";
            } 
        } #while 
        $string = implode($table,''); 
        $string = str_replace("'"," ",$string);
    }
    return $string;
}

function breadcrumbs($breadcrumbs=array()){
    if (count($breadcrumbs) != 0 and is_array($breadcrumbs) ) {
        $contenu .= '<ol class="breadcrumb">';
        foreach ($breadcrumbs as $key => $value) {
            if($key) {
                $contenu .= '<li>';
                $contenu .= '<a href="'.$value.'">'.$key.'</a>';
                $contenu .= '</li>';
            }
            else {
                $contenu .= '<li class="active">';
                $contenu .= $value;
                $contenu .= '</li>';
            }
        }
        $contenu .= '</ol>';
    }
    return $contenu;
}

function menu_gauche($menu_gauche){
    $contenu = '<div class="nav nav-pills nav-stacked" role="group" aria-label="...">';
    $contenu .= '<ul class="menu_gauche">';
    foreach ($menu_gauche as $key => $value) {
        $contenu .= '<li>';
        $contenu .= '<a href="'.base_url.$value[1].'"> <i class="glyphicon glyphicon-'.$value[0].'" ></i> '.$key.'</a>';
        $contenu .= '<li>';
    }
    $contenu .= '</ul>';
    $contenu .= '</div>';

    //instruction
    return $contenu;
}

function utf8_decode_array($array) {
    $a_decoded = array();
    $i=0;
    foreach ($array as $key => $a_value) {
        foreach ($a_value as $key_2 => $value_2) {
            $a_decoded[$i][utf8_decode($key_2)]=utf8_decode($value_2);
        }
        $i++;
    }
    return $a_decoded;
}

function afficher_html($id_div,$string,$frame="no") {
    $ajouter = "";
    $class = "";
    $contenu = '';
    if (preg_match("`^\.`",$id_div)) {
        $class=",".true;
    }

    $id_div_final = preg_replace("`^\.`","",$id_div);
    $id_div_final = preg_replace("`^#`","",$id_div_final);

    // $string = utf8_encode($string);
    if($frame!="no") {
        $ajouter = "window.parent.";   
    }
    $contenu.=javascript(''.$ajouter.'afficher_html(\''.$id_div_final.'\',\''.javascript_aff($string).'\''.$class.')');
    return $contenu;
}

function extension($nom_du_fichier) {
    $ext=strtolower(strrchr($nom_du_fichier,'.'));
    return $ext;
}

function tronquer($tocut , $max_caracteres , $space='1' , $points='1') {
        if (strlen($tocut)>$max_caracteres){
                if ($space=='1'){
                        $max_caracteres=strrpos(substr($tocut, 0, $max_caracteres), " ");
                }
                $tocut = substr($tocut, 0, $max_caracteres);
                if ($points=='1'){
                        $tocut.='...';
                }
        }
        return $tocut;
}

function random_letter($car) {
    $string = "";
    $chaine = "0123456789abcdefghijklmnpqrstuvwxy";
    srand((double)microtime()*1000000);
    for($i=0; $i<$car; $i++) {
        $string .= $chaine[rand()%strlen($chaine)];
    }
    return $string;
}

function unset_array($a_unset,$array) {
    foreach ($array as $key => $value) {
        if(in_array($key,$a_unset)) {
            unset ($array[$key]);
        }
    }
    return $array;
}

function writeInFile($myFile,$value) {
    $fp = fopen($myFile,"w+");
    fwrite($fp,$value);         
    fclose($fp);
}

function print2($array) {
    echo "<pre>";
    print_r($array);
    echo "</pre>";
}

function set_to_mktime($date_all) {
        $a_date_all = explode(" ",$date_all);
        $a_date = explode("/",$a_date_all[0]);
        $a_heure = explode(":",$a_date_all[1]);
        return mktime($a_heure[0],$a_heure[1],$a_heure[2],$a_date[1],$a_date[0],$a_date[2]);
}


// liste les jours fériés
function a_ferie() {
    //liste des feries 2016
    $a_ferie[] = "28/03/2016"; //Lundi de Pâques    28 Mars
    $a_ferie[] = "01/05/2016"; // Fête du Travail   1 Mai
    $a_ferie[] = "08/05/2016"; // 8 Mai 1945    8 Mai
    $a_ferie[] = "05/05/2016"; // Jeudi de l'Ascension  5 Mai
    $a_ferie[] = "16/05/2016"; // Lundi de Pentecôte    16 Mai
    $a_ferie[] = "14/07/2016"; // Fête Nationale    14 Juillet
    $a_ferie[] = "15/08/2016"; // Assomption    15 Août
    $a_ferie[] = "01/11/2016"; // La Toussaint  1 Novembre
    $a_ferie[] = "11/11/2016"; // Armistice     11 Novembre
    $a_ferie[] = "25/12/2016"; // Noël  25 Décembre
    return del_ferie_week($a_ferie);     
}

// Supprimer les feries qui tombe un week'end
function del_ferie_week($a_ferie){
    foreach ($a_ferie as $key => $ferie) {
        $datetime_ferie = \DateTime::createFromFormat('d/m/Y',$ferie)->format('D');
        if ($datetime_ferie == 'Sat' || $datetime_ferie == 'Sun') {
            unset($a_ferie[$key]);
        }
    }
    return $a_ferie;
}

// Retourne les nombres de jours travaillés
function nombre_de_jour_non_travaille($date_debut,$date_fin) {
    $start = DateTime::createFromFormat('d/m/Y H:i:s',$date_debut);
    $end = DateTime::createFromFormat('d/m/Y H:i:s',$date_fin);
    // ajout d'une journée la date de fin est exclu (bug?)
    $end->modify('+1 day');
    $period = new DatePeriod($start, new DateInterval('P1D'), $end);
    $days = 0;
    foreach($period as $dt) {
        $curr = $dt->format('D');
        //compter le nombre de jour
        if ($curr == 'Sat' || $curr == 'Sun') {
            $days++;
        }
        //ajouter les jours fériers
        if (in_array($dt->format('d/m/Y'), a_ferie())) {
           $days++;
        }               
    }
    return $days;
}

//retourne les nombres de secondes des jours travaillés sans les week-ends et compris dans une plage horaire de début et de fin.
function calcul_delai($plage_debut,$plage_fin,$date_debut,$date_fin) {
    if(isset($date_fin)) {
        //debug
        // echo "date_debut : ".$date_debut."<br>";
        // echo "date_fin : ".$date_fin."<br>";

        //mise en array de l'heure de la plage de début
        $a_plage_debut = explode(":",$plage_debut);
        $hh_plage_debut = $a_plage_debut[0];
        $mm_plage_debut = $a_plage_debut[1];

        //mise en array de l'heure de la plage de fin
        $a_plage_fin = explode(":",$plage_fin);
        $hh_plage_fin = $a_plage_fin[0];
        $mm_plage_fin = $a_plage_fin[1];

        // Separation de l'heure et de la date
        // debut
        $date_date_debut = current(explode(" ",$date_debut));
        $explode_date_debut = explode(" ",$date_debut);
        $heure_date_debut = $explode_date_debut[1];
        $a_date_date_debut = explode("/",$date_date_debut);
        $a_heure_date_debut = explode(":",$heure_date_debut);
        $jour_date_debut = $a_date_date_debut[0];
        $mois_date_debut = $a_date_date_debut[1];
        $annee_date_debut = $a_date_date_debut[2];
        $hh_date_debut = $a_heure_date_debut[0];
        $mm_date_debut = $a_heure_date_debut[1];
        $ss_date_debut = $a_heure_date_debut[2];

        // fin
        $date_date_fin = current(explode(" ",$date_fin));
        $explode_date_fin = explode(" ",$date_fin);
        $heure_date_fin = $explode_date_fin[1];
        $a_date_date_fin = explode("/",$date_date_fin);
        $a_heure_date_fin = explode(":",$heure_date_fin);
        $jour_date_fin = $a_date_date_fin[0];
        $mois_date_fin = $a_date_date_fin[1];
        $annee_date_fin = $a_date_date_fin[2];
        $hh_date_fin = $a_heure_date_fin[0];
        $mm_date_fin = $a_heure_date_fin[1];
        $ss_date_fin = $a_heure_date_fin[2];

        //si c'est le même jour on calcule juste la différence d'heure
        if($date_date_debut == $date_date_fin) {
                //plage de debut en mktime
                $plage_debut_mktime = mktime($hh_plage_debut,$mm_plage_debut,0,$mois_date_debut,$jour_date_debut,$annee_date_debut);

                //plage de fin en mktime
                $plage_fin_mktime = mktime($hh_plage_fin,$mm_plage_fin,0,$mois_date_fin,$jour_date_fin,$annee_date_fin);

                //heure de debut en mktime
                $heure_debut_mktime = mktime($hh_date_debut,$mm_date_debut,0,$mois_date_debut,$jour_date_debut,$annee_date_debut);

                //heure de fin en mktime
                $heure_fin_mktime = mktime($hh_date_fin,$mm_date_fin,0,$mois_date_fin,$jour_date_fin,$annee_date_fin);

                if ($heure_debut_mktime < $plage_debut_mktime && $heure_fin_mktime < $plage_debut_mktime) {
                    $delai = 0;
                }
                else {
                    // si l'heure de debut est en dessous de la plage de debut, on prend la plage de debut
                    if ($heure_debut_mktime < $plage_debut_mktime) {
                        $heure_debut_mktime = $plage_debut_mktime;
                    }
                    // si l'heure de fin est en dessus de la plage de fin, on prend la plage de fin
                    if ($heure_fin_mktime > $plage_fin_mktime) {
                        $heure_fin_mktime = $plage_fin_mktime;
                    }
                    $delai = $heure_fin_mktime - $heure_debut_mktime;
                }
        }
        else {
                // Calcul de nombre de jours entre les deux dates sans le premier et le dernier jour
                $datetime1 = new DateTime(str_replace("/","-",convert_date_fr_en($date_date_debut)));
                $datetime2 = new DateTime(str_replace("/","-",convert_date_fr_en($date_date_fin)));
                $interval = $datetime1->diff($datetime2);
                $nb_jour = $interval->format('%d%') - 1;

                // s'il y a juste une journée entre les deux intérvales date, on enlève pas
                if($nb_jour == -1)
                        $nb_jour = 0;

                // Nombre de jour non travaillé entre deux date
                $nb_non_travaille = nombre_de_jour_non_travaille($date_debut,$date_fin);

                // Nombre de jour travaille sans le premier et le dernier jour
                $nb_jour_travaille = $nb_jour - $nb_non_travaille;

                // Nombre de jours travaille en seconde
                $nb_jour_travaille_seconde = $nb_jour_travaille * 60 * 60 * 24;
                
                //on enleve les nombres d'heures non travaillé
                $nb_jour_travaille_seconde = (mktime($hh_plage_fin,$mm_plage_fin,0,0,0,1970) - mktime($hh_plage_debut,$mm_plage_debut,0,0,0,1970)) * $nb_jour_travaille;

                //---------------------------------------------------------------------------------------------------------------------------
                // Calcul du nombre d'heure passé le premier jour
                // --------------------------------------------------------------------------------------------------------------------------
                //plage de debut en mktime
                $plage_debut_mktime = mktime($hh_plage_debut,$mm_plage_debut,0,$mois_date_debut,$jour_date_debut,$annee_date_debut);

                //plage de fin en mktime
                $plage_fin_mktime = mktime($hh_plage_fin,$mm_plage_fin,0,$mois_date_debut,$jour_date_debut,$annee_date_debut);

                //heure de debut en mktime
                $heure_debut_mktime = mktime($hh_date_debut,$mm_date_debut,0,$mois_date_debut,$jour_date_debut,$annee_date_debut);

                // Si l'heure est en dessous de la plage de fin et en dessus de la plage de debut
                if ($heure_debut_mktime < $plage_fin_mktime && $heure_debut_mktime > $plage_debut_mktime) {
                    $nb_seconde_jour_1 = $plage_fin_mktime - $heure_debut_mktime;
                }
                elseif ($heure_debut_mktime > $plage_fin_mktime) {
                    $nb_seconde_jour_1 = 0;
                }
                elseif ($heure_debut_mktime < $plage_debut_mktime) {
                    $nb_seconde_jour_1 = $plage_fin_mktime - $plage_debut_mktime;
                    
                }

                // Fin calcul du nombre premier jour
                //---------------------------------------------------------------------------------------------------------------------------
                //---------------------------------------------------------------------------------------------------------------------------
                // Calcul du nombre d'heure passé le dernier jour
                // --------------------------------------------------------------------------------------------------------------------------
                //plage de debut en mktime
                $plage_debut_mktime = mktime($hh_plage_debut,$mm_plage_debut,0,$mois_date_fin,$jour_date_fin,$annee_date_fin);

                //plage de fin en mktime
                $plage_fin_mktime = mktime($hh_plage_fin,$mm_plage_fin,0,$mois_date_fin,$jour_date_fin,$annee_date_fin);

                //heure de fin en mktime
                $heure_fin_mktime = mktime($hh_date_fin,$mm_date_fin,0,$mois_date_fin,$jour_date_fin,$annee_date_fin);

                // Si l'heure est en dessous de la plage de fin et en dessus de la plage de debut
                if ($heure_fin_mktime < $plage_fin_mktime && $heure_fin_mktime > $plage_debut_mktime) {
                    $nb_seconde_jour_fin =  $heure_fin_mktime - $plage_debut_mktime;
                }
                elseif ($heure_debut_mktime > $plage_fin_mktime) {
                    $nb_seconde_jour_fin = $plage_fin_mktime - $plage_debut_mktime;
                }
                elseif ($heure_debut_mktime < $plage_debut_mktime) {
                    $nb_seconde_jour_fin = 0;
                }

                // Fin calcul du nombre premier jour
                //---------------------------------------------------------------------------------------------------------------------------

                // Calcul du délai
                if(!isset($nb_seconde_jour_1))
                    $nb_seconde_jour_1 = 0;
                $delai = $nb_jour_travaille_seconde + $nb_seconde_jour_1 + $nb_seconde_jour_fin;
        }
    }
    else {
        $delai = 0;
    }
    return $delai;
}

function date_vide($date) {
    if($date=="0000-00-00 00:00:00")
        return "";
    else
        return $date;
}

//converti les secondes en format lisible
function a_convert_seconde_human($seconde) {
        $h=intval($seconde / 3600);
        $m=intval(($seconde % 3600) / 60);
        $s=intval((($seconde % 3600) % 60));
        return array($h,$m,$s);
}

// 
function convert_date_fr_en($date){
    $date = str_replace("-","/",$date);
    $a_date = explode("/",$date);
    return $a_date[2]."/".$a_date[1]."/".$a_date[0];
}

function convert_date_en_fr($date,$sep="/"){
    $date = str_replace("-","/",$date);
    if(preg_match("` `",$date)) { //date time

    }
    else {
        $a_date = explode("/",$date);
        
    }
    return $a_date[2].$sep.$a_date[1].$sep.$a_date[0].$heure;
}

function datatable_ajax($url,$f_name_sarch){
    $contenu .= '
        <script type="text/javascript" language="javascript" >
            $(document).ready(function() {
                var dataTable = $("#show_res").DataTable( {
                    "processing": true,
                    "serverSide": true,
                    "language": {
                        "sProcessing":     "Traitement en cours...",
                        "sSearch":         "Rechercher&nbsp;:",
                        "sLengthMenu":     "Afficher _MENU_ &eacute;l&eacute;ments",
                        "sInfo":           "Affichage de l\'&eacute;l&eacute;ment _START_ &agrave; _END_ sur _TOTAL_ &eacute;l&eacute;ments",
                        "sInfoEmpty":      "Affichage de l`\'&eacute;l&eacute;ment 0 &agrave; 0 sur 0 &eacute;l&eacute;ment",
                        "sInfoFiltered":   "(filtr&eacute; de _MAX_ &eacute;l&eacute;ments au total)",
                        "sInfoPostFix":    "",
                        "sLoadingRecords": "Chargement en cours...",
                        "sZeroRecords":    "Aucun &eacute;l&eacute;ment &agrave; afficher",
                        "sEmptyTable":     "Aucune donn&eacute;e disponible dans le tableau",
                        "oPaginate": {
                            "sFirst":      "Premier",
                            "sPrevious":   "Pr&eacute;c&eacute;dent",
                            "sNext":       "Suivant",
                            "sLast":       "Dernier"
                        },
                        "oAria": {
                            "sSortAscending":  ": activer pour trier la colonne par ordre croissant",
                            "sSortDescending": ": activer pour trier la colonne par ordre d&eacute;croissant"
                        }
                    },
                    "ajax":{
                        url :"'.$url.'", // json datasource
                        type: "post",
                        data: function ( d ) {
                            d.other_post = $("#'.$f_name_search.'").serialize();
                        },                          
                        error: function(){  // error handling
                            $(".show_res-error").html("");
                            $("#show_res").append(\'<tbody class="show_res-error"><tr><th colspan="3">Pas de résultat</th></tr></tbody>\');
                            $("#liste_ajax_processing").css("display","none");
                        }
                    },
                    "initComplete": function (){
                        chargement();
                    }
                } );
            } );
        </script>
    ';
}

function insert($post,$table,$exept=array(),$debug=false) {

    $post=addslashes_array($post);
    //suppression des arrays inutiles
    $exept[]='_token';
    $exept[]='act';
    $exept[]='table';
    $exept[]='validate';
    $exept[]='id';
    $post = unset_array($exept,$post);
    $a_col = array_keys($post);
    $a_value = array_values($post);
    $col = "(`".implode($a_col,"`,`")."`)";
    $value = "('".implode($a_value,"','")."')";
    $req = "INSERT INTO `".$table."` ".$col." VALUES ".$value."";
    if ($debug == false) {
        $CI =& get_instance();
        $CI->db->query($req);
    }
    else {
        echo $req;
    }

}

function update($post,$table,$where="",$exept=array(),$debug=false) {
    $post=addslashes_array($post);
    //suppression des arrays inutiles
    $exept[]='_token';
    $exept[]='act';
    $exept[]='table';
    $exept[]='validate';
    $post = unset_array($exept,$post);
    $req = "UPDATE ".$table. " SET ";
    $i=1;
    $nb=count($post);
    foreach ($post as $key => $value) {
        if($i==$nb)
            $sep = "";
        else
            $sep = ",";
        
        $req .= $key."='".$value."' ".$sep;
        $i++;
    }
    $req .= " WHERE 1 ".$where;
    if ($debug == false) {
        $CI =& get_instance();
        $CI->db->query($req);
    }
    else {
        echo $req;
    }
}
?>
