jQuery(document).ready(function($) {
    detectHash();
});

function simple_form(id,url,input,data) {
    var token = $('meta[name="csrf_token"]').attr('content');
    for(var i in input) {
        id_a_input =  input[i];
        key_a_input = i;
        value = $('#' + id_a_input).val(); 
        data += "&" + key_a_input + "=" + value;
    }
    console.log(data);
    
    $.ajax({
        url: "" + url + "",
        cache: false,
        type: "POST",
        data: "_token=" + token + data,


        beforeSend: function() {
            $("#l_" + id + "").fadeIn();
        },
        success: function(data) {
            $("#r_" + id + "").html(data).fadeIn('slow');
            $("#l_" + id + "").fadeOut();
            chargement();
        },
        error:function (argument) {
            alert('Une erreur s\'est produite');
        }
    });
  
}

function drag_and_drop() { 
    $( ".draggable" ).draggable({

        snap : '.droppable',
        revert : true
    });
    $('.droppable').droppable({
        accept : '.draggable', // je n'accepte que le bloc ayant "drag" pour id
        hoverClass : "draggable-hover",
        drop : function(event, ui){
            // Info bloc
            id_menu = $(this).attr("data-id-menu");
            id_bloc = $(this).attr("data-id-bloc");
            rang_bloc = $(this).attr("data-rang-bloc");
            id_content = $(this).attr("data-id-content");
            // Info type_bloc
            type_bloc = ui.draggable.attr("id");
            switch (type_bloc) {
                case "text":
                    title_modal = "Ajouter ou modifier un bloc de texte"
                    console.log(title_modal);
                    break;
                case "slide":
                    title_modal = "Ajouter ou modifier un slideshow"
                    break;
                case "video":
                    title_modal = "Ajouter ou modifier une galerie vidéo"
                    break;
                case "gallery":
                    title_modal = "Ajouter ou modifier une galerie photo"
                    break;
            }
            mpU("/modal/bloc/" + type_bloc + "/add_ed_form", "id_menu=" + id_menu + "&id_bloc=" + id_bloc + "&rang_bloc=" + rang_bloc + "&type_bloc=" + type_bloc + "&id_content=" + id_content, title_modal,"wide");
        }
    });
}

$(window).bind('hashchange', function(e) {
    detectHash();
});

function verify(id_form, file) {
    if (file)
        file = "&file=" + file;
    else
        file = "";

    //pour les messages
    if (!is_exist("#m_" + id_form)) {
        $("#f_" + id_form).prepend('<div id="m_' + id_form + '"></div>');
    }

    //pour le loading
    if (!is_exist("#l_" + id_form)) {
        $("#b_" + id_form).append('<span id="l_' + id_form + '" style="display:none"><img src="/images/loading.gif"></span>');
    }
    //pour le loading
    if (!is_exist("r_" + id_form)) {
        $("#f_" + id_form).after('<div id="r_' + id_form + '"></div>');
    }

    var token = $('meta[name="csrf_token"]').attr('content');
    f_data = $("#f_" + id_form).serialize() + "&id_form=" + id_form;
    $.ajax({
        url: "/modal/register/verify",
        cache: false,
        type: "POST",
        data: "_token=" + token + "&" + f_data + file,
        beforeSend: function() {
            $("#l_" + id_form).fadeIn();
            $("#b_" + id_form).attr("disabled","disabled");
        },
        success: function(data) {
            var a_validate = data.validate
            var id_form = data.info_form.id_form;
            var file = data.info_form.file;
            var error = 0;
            for (var id in a_validate) {
                var message = a_validate[id];
                if (message != "OK") {
                    form_error(id_form, id, "show", message);
                    error ++;
                } else {
                    form_error(id_form, id, "hide", "");
                }
            }
            if(error==0) {
            	if(file) {
                    var func = file + ".start()";
                    eval(func);
            	}
            	else {
            		send_form(id_form);
            	}
            }
            else {
                $("#l_" + id_form).fadeOut();
                $("#b_" + id_form).removeAttr("disabled");
            }
            chargement();
        }
    });
}

function send_form(id_form) {
    var token = $('meta[name="csrf_token"]').attr('content');
    //recuperation des values
    f_data = $("#f_" + id_form).serialize()
    url = $("#f_" + id_form).attr("action");
    $.ajax({
        url: url,
        cache: false,
        type: "POST",
        data: "_token=" + token + "&" + f_data,
        beforeSend: function() {},
        success: function(data) {
            $("#l_" + id_form).fadeOut();
            $("#b_" + id_form).removeAttr("disabled");
            $("#r_" + id_form).html(data);
            if (is_exist("#i_" + id_form)) {
                $("#i_" + id_form).fadeIn();
                setTimeout(function() {
                    $("#i_" + id_form).fadeOut();
                }, 3000);
            }
        }
    });
}

function form_error(id_form, id, action, message) {
    $("#f_" + id_form + " #help_" + id).remove();
    $("#f_" + id_form + " #" + id).after('<div id="help_' + id + '" class="arrow_box_error">' + message + '</div>');
    if (action == "show") {
        $("#f_" + id_form + " #fg_" + id).addClass("has-error");
        $("#f_" + id_form + " #help_" + id).fadeIn();
    } else {
        $("#f_" + id_form + " #fg_" + id).removeClass("has-error");
        $("#f_" + id_form + " #help_" + id).remove();
    }
}



function is_exist(id) {
    id = id.replace("#", "");
    if ($("#" + id).length) {
        return true;
    } else {
        return false;
    }
}


function f_keyup(id) {
    var valSearch = $("#" + id).val();
    var urlSearch = $("#" + id).attr("data-url");
    var c = $("#" + id).attr("data-c");
    var f = $("#" + id).attr("data-f");
    $.ajax({
        url: urlSearch,
        cache: false,
        type: "POST",
        data: "q=" + valSearch + "&c=" + c + "&actF=" + f,
        beforeSend: function() {
            $("#l_" + id).fadeIn();
        },
        success: function(data) {
            $("#r_" + f).html(data).fadeIn('slow');
            $("#l_" + id).fadeOut();
            console.log("r_id : #r_" + f)
        }
    });
}

function show_hide(id, rub) {
    if (rub == "recette") {
        id_form = "f_add_ed_form";
        if (id == 1 || id == 2 || id == 3) {
            var show = ["categorie", "titre", "tppreparation", "tpcuisson", "difficulte", "nbpersonne", "ingredient", "preparation", "lien", "image"];
            var hide = ["description"];
            var a_required = ["categorie", "titre", "difficulte", "ingredient", "preparation"];
        } else if (id == 4 || id == 6 || id == 7) {
            var show = ["categorie", "titre", "description", "lien", "image"];
            var hide = ["tppreparation", "tpcuisson", "difficulte", "nbpersonne", "ingredient", "preparation"];
            var a_required = ["categorie", "titre", "description"];
        } else if (id == 5) {
            var show = ["categorie", "titre", "description", "lien", "image"];
            var hide = ["tppreparation", "tpcuisson", "difficulte", "nbpersonne", "ingredient", "preparation"];
            var a_required = ["categorie", "titre", "lien"];
        }
    }
    if (hide) {
        //cacher
        for (index = 0; index < hide.length; index++) {
            $("#" + id_form + " #group_" + hide[index]).fadeOut();
            // console.log("#" + id_form + " #group_" + hide[index]);
        }
        //afficher
        for (index = 0; index < show.length; index++) {
            $("#" + id_form + " #group_" + show[index]).fadeIn();
        }
        //required
        $("#" + id_form + " [id^=e_]").remove();
        $('.required').removeClass("required");
        for (index = 0; index < a_required.length; index++) {
            $("#" + id_form + " #" + a_required[index]).addClass("required");
            $("#" + id_form + " #" + a_required[index]).attr("data-obl", "Champ obligatoire");
        }
        // Creation des champs obligatoires
        required = "";
        $("#" + id_form + " [class*=required] ").each(function(index, el) {
            id = $(this).attr("id");
            obl = $(this).attr("data-obl");
            min = $(this).attr("data-min");
            max = $(this).attr("data-max");
            if (min) {
                min = min
            } else {
                min = "";
            }
            if (max) {
                max = max
            } else {
                max = "";
            }
            required = required + id + "<;>" + obl + "<;>" + min + "<;>" + max + "|";
        });
        $("#" + id_form + " [class*=req_img] ").each(function(index, el) {
            id = $(this).attr("id");
            obl = $(this).attr("data-obl");
            req_img = req_img + id + "<;>" + obl + "<;><;>|";
        });
        required = required.substring(0, required.length - 1);
        req_img = req_img.substring(0, req_img.length - 1);
        console.log(required);
        $("[name=required]").attr('value', required);
        // Fin creation des champs obligatoire  	
    }
}

function remove(id) {
    $(id).hide(100).remove();
}

function detectHash() {
    url = location.href;
    if (url.match(/#!/)) {
        a_url = url.split("#!");
        urlP = a_url[0];
        myHash = a_url[1];
        urldecode(myHash);
    }
}

function urldecode(str) {
    str = decodeURIComponent((str + '').replace(/\+/g, '%20'));
    console.log(str);
}


function expandMe(id) {
    idExpand = "#" + id;
    classExpand = "." + id;
    if ($(idExpand + " ul.tree:first").is(":visible")) {
        $(idExpand + " ul.tree").hide("50");
        $(classExpand).find("i").attr("class", "icon-plus");
        id_close = $(idExpand + " ul.tree:first").attr("id");
        removeData("#list_div_showed", "data-info", id_close);
    } else {
        $(idExpand + " ul.tree:first").show("50");
        $(classExpand).find("i").attr("class", "icon-minus");
        id_open = $(idExpand + " ul.tree:first").attr("id");
        addData("#list_div_showed", "data-info", id_open);
    }
}

function in_array(value, array) {
    return array.indexOf(value) > -1;
}

function del_a_duplicate(array) {
    var i, j, len = array.length,
        out = [],
        obj = {};
    for (i = 0; i < len; i++) {
        obj[array[i]] = 0;
    }
    for (j in obj) {
        out.push(j);
    }
    return out;
}


function afficher_html(id_html, le_html, v_class) {
    if (v_class) {
        $('.' + id_html).html(le_html).fadeIn();
    } else {
        $('#' + id_html).html(le_html).fadeIn();
    }
    chargement();
}

function replace_html(id_html, le_html, c) {
    $(id_html).replaceWith(le_html).fadeIn();
    if (c) {
        c;
        console.log("c : " + c);
    }
    arrangeLi();
}

function scrollTop() {
    $("html, body").animate({
        scrollTop: 0
    }, "slow");
}

function aller_a(id) {
    if ($("#" + id).offset()) {
        $('html,body').animate({
            scrollTop: $("#" + id).offset().top
        }, 'slow');
    }
}


$.fn.clearForm = function() {
    return this.each(function() {
        var type = this.type,
            tag = this.tagName.toLowerCase();
        if (tag == 'form')
            return $(':input', this).clearForm();
        if (type == 'text' || type == 'password' || tag == 'textarea' || type == 'file')
            this.value = '';
        else if (type == 'checkbox' || type == 'radio')
            this.checked = false;
        else if (tag == 'select')
            this.selectedIndex = -1;
    });
};

function reset_form(id_form) {
    $('#f_' + id_form).each(function() {
        this.reset();
    });
}

//correction bug j'ai enlevé le remove
function jquerize(f_name, url, f_data, res, search) {
    var token = $('meta[name="csrf_token"]').attr('content');
    var button_value = $("#f_" + f_name + " [type=submit]").val();

    data_search = "";
    if (search) {
        liste_input = $("#" + search + "_input").val();
        liste_input = liste_input + "id_rub-rub-debut"
        console.log(liste_input);
        a_liste_input = liste_input.split("-");
        for (i = 0; i < a_liste_input.length; i++) {
            un_input_value = $("#" + a_liste_input[i]).val();
            if (un_input_value) {
                data_search += "&" + a_liste_input[i] + "=" + un_input_value;
            }
        }
    }
    if (data_search) data_search += "&search_form=y"


    //formulaire ou pas
    if (f_data == "formulaire") {
        f_data = $("#f_" + f_name + "").serialize();
    }

    //regarder s'il y a pas un formulaire de recherche

    //affichage du loading
    $("#l_" + f_name + "").fadeIn();
    //fade_out du resultat
    //ajax
    $.ajax({
        url: "" + url + "",
        cache: false,
        type: "POST",
        data: "_token=" + token + "&" + f_data + data_search,
        beforeSend: function() {
            //supprimer tipsy
            $("#f_" + f_name + " [type=submit]").val("Patientez svp ...");
            $("#f_" + f_name + " [type=submit]").attr("disabled", "disabled");
        },
        success: function(data) {
            if (res) {
                $("#" + res + "").html(data).fadeIn();
            } else {
                $("#r_" + f_name + "").html(data).fadeIn('slow');
            }
            $("#f_" + f_name + " [type=submit]").val(button_value);
            $("#f_" + f_name + " [type=submit]").removeAttr('disabled');
            $("#l_" + f_name + "").fadeOut();
            setTimeout(function() {
                aller_a("m_" + f_name);
            }, 500);
            chargement();
        }
    });
}

(function($) {
    $.fn.selectionner = function() {
        return this.each(function() {
            $(this).click(function() {
                $(this).select();
            })
        });
    };
})(jQuery);

$(function() {
    chargement();
});

function mpClose(timeout) {
    if (timeout) {
        setTimeout(function() {
            $('.modal.in').modal('hide');
        }, timeout);
    } else {
        $('.modal.in').modal('hide');
    }
}

function mpU_new(url, f_data, title) {
    mpClose();
    setTimeout(function() {
        mpU(url, f_data, title);
    }, 500);
}

function mpmp(url,data) {
    if(data.length>0) {
        data = "?" + data
    }
    else {
        data = "";
    }
    $.magnificPopup.open({
        items:{
            type:'ajax',
            src:url + data
        },
        callbacks: {
            beforeOpen: function() { 
                this.wrap.removeAttr('tabindex');
            }
        },
        fixedContentPos:"true"
    })
}

function mpU(url, f_data, title,wide) {

    if (is_exist('myModal')) {
        mpClose();
    }
    $("#myModal").modal()
    if(wide=="wide") {
         $(".modal-dialog").addClass('modal-wide');  
    }
    var token = $('meta[name="csrf_token"]').attr('content');
    $.ajax({
        url: "" + url + "",
        cache: false,
        type: "post",
        data: "_token=" + token + "&" + f_data,
        beforeSend: function() {
            $("#myModalLabel").html(title);

        },
        success: function(data) {
            $(".modal-body").html(data).hide();
            $(".modal-body").fadeIn();
            chargement();
        }
    });
    $("#myModal").on("hide.bs.modal", function(e) {
        //on supprimer le contenu
        $("#myModalContent").html("Patientez svp ...");
        //le modal a tendance à forker donc on supprime le reste et on garde le premier
        $('[id="myModal"]:not(#myModal:first)').remove();
        $(".modal-dialog").removeClass('modal-wide');
    })
    $.fn.modal.Constructor.prototype.enforceFocus = function() {
      modal_this = this
      $(document).on('focusin.modal', function (e) {
        if (modal_this.$element[0] !== e.target && !modal_this.$element.has(e.target).length 
        && !$(e.target.parentNode).hasClass('cke_dialog_ui_input_select') 
        && !$(e.target.parentNode).hasClass('cke_dialog_ui_input_text')) {
          modal_this.$element.focus()
        }
      })
    };    
}

function msgModal(type,message,timeout) {
	$("#myModalContent").html('<div class="alert alert-' + type + '">' + message + '</div>').fadeIn();
	$("#myModalContent .alert").css("margin-bottom","0px");
    if(timeout != 0)
        setTimeout(function() { $('#myModal').modal('hide'); },timeout);
}

function msg(id, type, msg) {
    $("#" + id).html('<div class="alert alert-' + type + '"><button type="button" class="close" data-dismiss="alert">&times;</button>' + msg + '</div>').fadeIn();
    aller_a(id);
}

// setup radio and checkbox
function setupLabel() {
    if ($('.label_check input').length) {
        $('.label_check').each(function() {
            $(this).removeClass('c_on');
        });
        $('.label_check input:checked').each(function() {
            $(this).parent('label').addClass('c_on');
        });
    };
    if ($('.label_radio input').length) {
        $('.label_radio').each(function() {
            $(this).removeClass('r_on');
        });
        $('.label_radio input:checked').each(function() {
            $(this).parent('label').addClass('r_on');
        });
    };
};

function timer(time, update, complete) {
    var start = new Date().getTime();
    var interval = setInterval(function() {
        var now = time - (new Date().getTime() - start);
        if (now <= 0) {
            clearInterval(interval);
            complete();
        } else update(Math.floor(now / 1000));
    }, 100); // the smaller this number, the more accurate the timer will be
}

function resetAlert() {
    $("select,input,textarea").change(function() {
        id = $(this).attr("id");
        if (!id) {
            id = $(this).attr("name");
        }
        $("#e_" + id).fadeOut('slow', function() {
            $("#e_" + id).remove();
        });
    });
}

function alertMe(id, typeMsg, Msg, timeout) {
    console.log(id);
    if ($('#m_' + id).is(':visible')) {
        // do nothin
    } else {
        $('#m_' + id).fadeIn();
    }
    if (typeMsg == "l") {
        $("#m_" + id).html("<div class='alert alert-warning'><img src='img/ajax-loader.gif'> Patientez svp ... </div>");
    } else {
        $("#m_" + id).html("<div class='alert alert-" + typeMsg + "'><button type='button' class='close' data-dismiss='alert'>&times;</button>" + Msg + "</div>");
    }
    if (timeout) {
        setTimeout(function() {
            $("#m_" + id).fadeOut('slow', function() {
                $("#m_" + id).html("");
                $("#m_" + id).fadeIn();
            });
        }, timeout);
    }
}

function modal() {
    if (!is_exist("myModal")) {
        $("body").prepend("<div class=\"modal fade modal_counter\" id=\"myModal\" tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"myModalLabel\" aria-hidden=\"true\"><div class=\"modal-dialog\"><div class=\"modal-content\"><div class=\"modal-header\"><button type=\"button\" class=\"close\" data-dismiss=\"modal\" aria-label=\"Close\"><span aria-hidden=\"true\">&times;</span></button><h4 class=\"modal-title\" id=\"myModalLabel\"></h4></div><div id=\"myModalContent\" class=\"modal-body\">Patientez svp ...</div></div></div></div>");
    }
}

function modal_alert() {
    $("body").prepend("<div class=\"modal fade\" id=\"modal_alert\" tabindex=\"-1\" role=\"dialog\" aria-labelledby=\"myModalLabel\" aria-hidden=\"true\"><div class=\"modal-dialog\"><div class=\"modal-content\"><div class=\"modal-body\"></div><div class=\"modal-footer\"></div></div></div></div>");
}

function lightboxAjax() {
    $("[rel='lightboxAjax']").magnificPopup({
        type: 'ajax',
        closeOnContentClick: false,
        closeOnBgClick: false,
        showCloseBtn: false
    });
}

function lightbox(rel_name) {
    $("[rel='" + rel_name + "']").magnificPopup({
        gallery: {
            enabled: true
        },
        removalDelay: 300,
        callbacks: {
            beforeOpen: function() {
                // just a hack that adds mfp-anim class to markup 
                this.st.image.markup = this.st.image.markup.replace('mfp-figure', 'mfp-figure mfp-with-anim');
                this.st.mainClass = this.st.el.attr('data-effect');
            }
        },
        type: 'image',
        image: {
            tError: '<a href="%url%">l\'image #%curr%</a> ne peut pas être chargée.',
            titleSrc: function(item) {
                return item.el.attr('title');
                console.log('ici');
            }
        }
    });
    // Image popups
    // $("[rel='lightbox']").magnificPopup({
    //   delegate: 'a',
    //   type: 'image',
    //   removalDelay: 500, //delay removal by X to allow out-animation
    //   callbacks: {
    //     beforeOpen: function() {
    //       // just a hack that adds mfp-anim class to markup 
    //        this.st.image.markup = this.st.image.markup.replace('mfp-figure', 'mfp-figure mfp-with-anim');
    //        this.st.mainClass = this.st.el.attr('data-effect');
    //     }
    //   },
    //   closeOnContentClick: true,
    //   midClick: true // allow opening popup on middle mouse click. Always set it to true if you don't provide alternative source.
    // });
}

function set_online() {
    $.ajax({
        url: "/modal/register/set_online",
        cache: false,
        type: "get"
    });
}

function nb_mail() {
    $.ajax({
        url: "/modal/register/nb_mail",
        cache: false,
        type: "get",
        success:function(data) {
            if(data==0) {
                $(".nb_message").html('<span class="label label-default">' + data +  '</span>');
            }
            else {
                $(".nb_message").html('<span class="label label-danger">' + data +  '</span>');
            }
        }
    });    
}

function sleepFor( sleepDuration ){
    var now = new Date().getTime();
    while(new Date().getTime() < now + sleepDuration){ /* do nothing */ } 
}

function updateAllMail() {
    if(is_exist("r_list_all_message")) {
        //on recupere le nombre de message actuel      
        nb_message = $(".nb_message").first().text();
        //console.log("nb_message : " + nb_message);
        //si on l'a jamais actualisé, on set le nombre de message sur la liste
             
        if(!is_exist("nb_message_on_list")) {
            $("#r_list_all_message").append('<div id="nb_message_on_list" data-nb="' + nb_message + '"></div>')
            //console.log("Add #nb_message_on_list");
        }
        //on check si le nombre de message est bon sinon on actualise
        nb_message_list = $("#nb_message_on_list").attr("data-nb");
        //console.log("nb_message_list : " + nb_message_list);
        if(nb_message != nb_message_list) {
            //console.log("New msg detected let's refresh");
            $.ajax({
                url: "/modal/message/listAllMessage",
                cache: false,
                type: "get",
                success:function(data) {
                    $("#r_list_all_message").html(data);
                }
            });             

        }

        if(is_exist("#r_liste_message")) {
            //get id_to
            id_to = $("#f_send_message #to").val();
            $.ajax({
                url: "/modal/message/get_nb_msg?to=" + id_to,
                cache: false,
                type: "get",
                success:function(nb_message) {
                    console.log("nb_message : " + nb_message);
                    if(nb_message != 0) {
                        console.log("the nb message =  " + nb_message + " let's refresh");
                        $.ajax({
                            url: "/modal/message/update_msg?to=" + id_to,
                            cache: false,
                            type: "get",
                            success:function(data) {
                                $("#r_liste_message").html(data);
                            }
                        });
                    }
                }
            });
        }

    }
}

function update_rc() {
    //set_online();
    // nb_mail();
    // setTimeout(function() {
    //     updateAllMail()
    // },1000);
}

function chargement() {
    setTimeout(function() {
        $('.focus').focus();
    }, 100);
    $('#cocheTout').click(function() {
        var cases = $("#cases").find(':checkbox');
        if (this.checked) {
            cases.attr('checked', true);
            $('#cocheText').html('Tout decocher');
        } else {
            cases.attr('checked', false);
            $('#cocheText').html('Cocher tout');
        }
    });

    path = window.location.pathname;
    if(path != "/connect") {
        update_rc();
        setInterval(function(){ 
            update_rc();
        }, 10000);
    }
    $('.carousel').carousel({interval: 2000});
    drag_and_drop();

    $('.timepicker').datetimepicker({
        datepicker:false,
        format:'H:i'
    });

    $( ".datePicker" ).datepicker({dateFormat: 'dd/mm/yy', firstDay:1 });
    //debut datePickerNaiss
    // $(".datePickerNaiss").datepicker({
    //      changeMonth: true,
    //      changeYear: true,
    //      yearRange: "-100:-13",
    //      dateFormat: 'dd/mm/yy',
    //      defaultDate: new Date(2002, 01, 01)
    // });
    //
    // $(".datePickerNaissNoLimit").datepicker({
    //      changeMonth: true,
    //      changeYear: true,
    //      yearRange: "-100:-1",
    //      dateFormat: 'dd/mm/yy',
    //      //defaultDate: new Date(2002, 01, 01)
    // });
    //$.fn.modal.Constructor.prototype.enforceFocus = function() {};
    //fin datePickerNaiss
    $('.tooltip_it').tooltip();
    resetAlert();
    modal();
    lightbox("lightbox");
     $('.multiselect_it').multiselect();
}

$(document).delegate('.forceTab', 'keydown', function(e) {
    var keyCode = e.keyCode || e.which;
    if (keyCode == 9) {
        e.preventDefault();
        var start = $(this).get(0).selectionStart;
        var end = $(this).get(0).selectionEnd;
        // set textarea value to: text before caret + tab + text after caret
        $(this).val($(this).val().substring(0, start) + "\t" + $(this).val().substring(end));
        // put caret at right position again
        $(this).get(0).selectionStart =
            $(this).get(0).selectionEnd = start + 1;
    }
});

function ifVar(myVar) {
    if (/^\$.*/.test(myVar))
        line = myVar;
    else
        line = "\"" + myVar + "\"";
    return line;
}


function log(texte) {
    al(texte, "error", 60000);
}


function al(msg, type, delay, valign, align) {
    if (!delay)
        delay = 4000;
    if (!valign)
        valign = "top";
    if (!align)
        align = "right";

    $.al(msg, {
        ele: 'body', // which element to append to
        type: type, // (null, 'info', 'error', 'success')
        offset: {
            from: valign,
            amount: 5
        }, // 'top', or 'bottom'
        align: align, // ('left', 'right', or 'center')
        width: 250, // (integer, or 'auto')
        delay: delay,
        allow_dismiss: true,
        stackup_spacing: 10 // spacing between consecutively stacked growls.
    });
}

function divStayOnTop(idDiv) {
    var window_top = $(window).scrollTop();
    //on ajoute un anchor anotre div
    if ($(idDiv + '-anchor').is(':visible')) {
        var div_top = $(idDiv + '-anchor').offset().top;
        if (window_top > div_top) {
            $(idDiv).addClass('divStayOnTop');
        } else {
            $(idDiv).removeClass('divStayOnTop');
        }
    }
}


//-------------------------------------------------------------------------#
// al
//-------------------------------------------------------------------------#
(function() {
    var e;
    e = jQuery;
    e.al = function(t, n) {
        var r, i, s;
        n = e.extend({}, e.al.default_options, n);
        r = e("<div>");
        r.attr("class", "bootstrap-growl alert");
        if (n.type) {
            r.addClass("alert-" + n.type)
        }
        if (n.allow_dismiss) {
            r.append('<span class="close" data-dismiss="alert">&times;</span>')
        }
        r.append(t);
        if (n.top_offset) {
            n.offset = {
                from: "top",
                amount: n.top_offset
            }
        }
        s = n.offset.amount;
        e(".bootstrap-growl").each(function() {
            return s = Math.max(s, parseInt(e(this).css(n.offset.from)) + e(this).outerHeight() + n.stackup_spacing)
        });
        i = {
            position: n.ele === "body" ? "fixed" : "absolute",
            margin: 0,
            "z-index": "9999",
            display: "none"
        };
        i[n.offset.from] = s + "px";
        r.css(i);
        if (n.width !== "auto") {
            r.css("width", n.width + "px")
        }
        e(n.ele).append(r);
        switch (n.align) {
            case "center":
                r.css({
                    left: "50%",
                    "margin-left": "-" + r.outerWidth() / 2 + "px"
                });
                break;
            case "left":
                r.css("left", "20px");
                break;
            default:
                r.css("right", "20px")
        }
        r.fadeIn();
        if (n.delay > 0) {
            r.delay(n.delay).fadeOut(function() {
                return e(this).alert("close")
            })
        }
        return r
    };
    e.al.default_options = {
        ele: "body",
        type: "info",
        offset: {
            from: "top",
            amount: 20
        },
        align: "right",
        width: 250,
        delay: 4e3,
        allow_dismiss: true,
        stackup_spacing: 10
    }
}).call(this)

function htmlentities(e) {
    e = e.replace(/"/g, "&quot;");
    e = e.replace(/&/g, "&");
    e = e.replace(/\'/g, "&#39;");
    e = e.replace(/</g, "&lt;");
    e = e.replace(/>/g, "&gt;");
    e = e.replace(/\^/g, "&circ;");
    e = e.replace(/‘/g, "&lsquo;");
    e = e.replace(/’/g, "&rsquo;");
    e = e.replace(/“/g, "&ldquo;");
    e = e.replace(/”/g, "&rdquo;");
    e = e.replace(/•/g, "&bull;");
    e = e.replace(/–/g, "&ndash;");
    e = e.replace(/—/g, "&mdash;");
    e = e.replace(/˜/g, "&tilde;");
    e = e.replace(/™/g, "&trade;");
    e = e.replace(/š/g, "&scaron;");
    e = e.replace(/›/g, "&rsaquo;");
    e = e.replace(/œ/g, "&oelig;");
    e = e.replace(//g, "&#357;");
    e = e.replace(/ž/g, "&#382;");
    e = e.replace(/Ÿ/g, "&Yuml;");
    e = e.replace(/¡/g, "&iexcl;");
    e = e.replace(/¢/g, "&cent;");
    e = e.replace(/£/g, "&pound;");
    e = e.replace(/¥/g, "&yen;");
    e = e.replace(/¦/g, "&brvbar;");
    e = e.replace(/§/g, "&sect;");
    e = e.replace(/¨/g, "&uml;");
    e = e.replace(/©/g, "&copy;");
    e = e.replace(/ª/g, "&ordf;");
    e = e.replace(/«/g, "&laquo;");
    e = e.replace(/¬/g, "&not;");
    e = e.replace(/­/g, "&shy;");
    e = e.replace(/®/g, "&reg;");
    e = e.replace(/¯/g, "&macr;");
    e = e.replace(/°/g, "&deg;");
    e = e.replace(/±/g, "&plusmn;");
    e = e.replace(/²/g, "&sup2;");
    e = e.replace(/³/g, "&sup3;");
    e = e.replace(/´/g, "&acute;");
    e = e.replace(/µ/g, "&micro;");
    e = e.replace(/¶/g, "&para");
    e = e.replace(/·/g, "&middot;");
    e = e.replace(/¸/g, "&cedil;");
    e = e.replace(/¹/g, "&sup1;");
    e = e.replace(/º/g, "&ordm;");
    e = e.replace(/»/g, "&raquo;");
    e = e.replace(/¼/g, "&frac14;");
    e = e.replace(/½/g, "&frac12;");
    e = e.replace(/¾/g, "&frac34;");
    e = e.replace(/¿/g, "&iquest;");
    e = e.replace(/À/g, "&Agrave;");
    e = e.replace(/Á/g, "&Aacute;");
    e = e.replace(/Â/g, "&Acirc;");
    e = e.replace(/Ã/g, "&Atilde;");
    e = e.replace(/Ä/g, "&Auml;");
    e = e.replace(/Å/g, "&Aring;");
    e = e.replace(/Æ/g, "&AElig;");
    e = e.replace(/Ç/g, "&Ccedil;");
    e = e.replace(/È/g, "&Egrave;");
    e = e.replace(/É/g, "&Eacute;");
    e = e.replace(/Ê/g, "&Ecirc;");
    e = e.replace(/Ë/g, "&Euml;");
    e = e.replace(/Ì/g, "&Igrave;");
    e = e.replace(/Í/g, "&Iacute;");
    e = e.replace(/Î/g, "&Icirc;");
    e = e.replace(/Ï/g, "&Iuml;");
    e = e.replace(/Ð/g, "&ETH;");
    e = e.replace(/Ñ/g, "&Ntilde;");
    e = e.replace(/Ò/g, "&Ograve;");
    e = e.replace(/Ó/g, "&Oacute;");
    e = e.replace(/Ô/g, "&Ocirc;");
    e = e.replace(/Õ/g, "&Otilde;");
    e = e.replace(/Ö/g, "&Ouml;");
    e = e.replace(/×/g, "&times;");
    e = e.replace(/Ø/g, "&Oslash;");
    e = e.replace(/Ù/g, "&Ugrave;");
    e = e.replace(/Ú/g, "&Uacute;");
    e = e.replace(/Û/g, "&Ucirc;");
    e = e.replace(/Ü/g, "&Uuml;");
    e = e.replace(/Ý/g, "&Yacute;");
    e = e.replace(/Þ/g, "&THORN;");
    e = e.replace(/ß/g, "&szlig;");
    e = e.replace(/à/g, "&aacute;");
    e = e.replace(/á/g, "&aacute;");
    e = e.replace(/â/g, "&acirc;");
    e = e.replace(/ã/g, "&atilde;");
    e = e.replace(/ä/g, "&auml;");
    e = e.replace(/å/g, "&aring;");
    e = e.replace(/æ/g, "&aelig;");
    e = e.replace(/ç/g, "&ccedil;");
    e = e.replace(/è/g, "&egrave;");
    e = e.replace(/é/g, "&eacute;");
    e = e.replace(/ê/g, "&ecirc;");
    e = e.replace(/ë/g, "&euml;");
    e = e.replace(/ì/g, "&igrave;");
    e = e.replace(/í/g, "&iacute;");
    e = e.replace(/î/g, "&icirc;");
    e = e.replace(/ï/g, "&iuml;");
    e = e.replace(/ð/g, "&eth;");
    e = e.replace(/ñ/g, "&ntilde;");
    e = e.replace(/ò/g, "&ograve;");
    e = e.replace(/ó/g, "&oacute;");
    e = e.replace(/ô/g, "&ocirc;");
    e = e.replace(/õ/g, "&otilde;");
    e = e.replace(/ö/g, "&ouml;");
    e = e.replace(/÷/g, "&divide;");
    e = e.replace(/ø/g, "&oslash;");
    e = e.replace(/ù/g, "&ugrave;");
    e = e.replace(/ú/g, "&uacute;");
    e = e.replace(/û/g, "&ucirc;");
    e = e.replace(/ü/g, "&uuml;");
    e = e.replace(/ý/g, "&yacute;");
    e = e.replace(/þ/g, "&thorn;");
    e = e.replace(/ÿ/g, "&yuml;");
    return e
}


jQuery(document).ready(function($) {
    var $allVideos = $("iframe[src^='//www.youtube.com']"),
        // The element that is fluid width
        $fluidEl = $("body");

    // Figure out and save aspect ratio for each video
    $allVideos.each(function() {
        $(this)
            .data('aspectRatio', this.height / this.width)
        // and remove the hard coded width/height
        .removeAttr('height')
            .removeAffttr('width');
    });

    // When the window is resized
    $(window).resize(function() {
        var newWidth = $fluidEl.width();
        // Resize all videos according to their own aspect ratio
        $allVideos.each(function() {
            var $el = $(this);
            $el
                .width(newWidth)
                .height(newWidth * $el.data('aspectRatio'));
        });
        // Kick off one resize to fix all videos on page load
    }).resize();
});